/*  Copyright 2012 DaMagicWobber

    Big Thanks to MorpheusX(AUT) (Website: http://www.phogue.net/forumvb/member.php?565-MorpheusX(AUT))
	and leibhold (Website: http://www.phogue.net/forumvb/member.php?849-leibhold) 
	for the hard work on the plugin and the Webpage
 
 *	DaMagicWoBBeR (Website: http://www.phogue.net/forumvb/member.php?15149-DaMagicWoBBeR)
 
    DaMagicWobber Plugins for Procon is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    DaMagicWoBBeR Plugins for Procon is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with DaMagicWobber Plugins for Procon.  If not, see <http://www.gnu.org/licenses/>.

 */

using System;
using System.Collections.Generic;
using System.Text.RegularExpressions;
using System.Threading;
using PRoCon.Core;
using PRoCon.Core.Plugin;
using PRoCon.Core.Players;
using MySql.Data.MySqlClient;

namespace PRoConEvents
{
	public class BanManager : PRoConPluginAPI, IPRoConPluginInterface
	{
		#region variables & constructor

		#region connection information
		/// <summary>
		/// hostname of the gameserver/procon-layer of the current connection
		/// </summary>
		private String strHostName;
		/// <summary>
		/// (rcon-)port of the gameserver/procon-layer of the current connection
		/// </summary>
		private String strPort;
		/// <summary>
		/// version of the current Procon-instance
		/// </summary>
		private String strPRoConVersion;

		#endregion

		#region dictionaries and lists

		/// <summary>
		/// provides a dictionary of players on the server with threadsafe method's
		/// </summary>
		private ThreadSafeCBanDic threadSafeCBanDic;
		/// <summary>
		/// provides a dictionary of checked players with threadsafe method's
		/// </summary>
		private ThreadSafeCleanPlayerDic threadSafeCleanPlayerDic;
		/// <summary>
		/// CServerInfo-object for the current connection
		/// </summary>
		private CServerInfo csiServerInfo;

		#endregion

		#region MySql variables and settings

		/// <summary>
		/// queryport from gameserver needed for the webpage
		/// </summary>
		private int intqport;
		
		/// <summary>
		/// represents the connectionstring
		/// </summary>
		private MySqlConnectionStringBuilder mySqlStringBuilder;

		#endregion

		#region plugin settings

		/// <summary>
		/// keep the gameservers banlist empty to avoid crashes
		/// </summary>
		private enumBoolYesNo ebEmptyServerBanlist;
		/// Dont kick player just announce findings for test
		/// </summary>
		private enumBoolYesNo ebEnableIngameAdmin;
		// LEIBHOLD HACK ADDED
		private enumBoolYesNo ebTestrun;
		private enumBoolYesNo ebEmptyServerPBBanlist;
		/// <summary>
		/// toggles whether kicked players will be listed in the plugin-console
		/// </summary>
		private enumBoolYesNo ebPrintKicksToConsole;
		/// <summary>
		/// toggles whether the plugin react on Punktbuster Kicks/Bans
		/// </summary>
		private enumBoolYesNo ebPBDisable;
		/// <summary>
		/// defines the Servergroup the Server belongs to (0 is global ban)
		/// </summary>>
		private int servergroup;
		//debug level 1 = min 9 = verbose
		private int ebDebugLevel;
		/// <summary>
		/// sly-command used by the admin
		/// </summary>
		private string strSlayCommand;
		/// <summary>
		/// kick-command used by the admin
		/// </summary>
		private string strKickCommand;
		/// <summary>
		/// Roundban-command used by the admin
		/// </summary>
		private string strRoundBanCommand;
		/// <summary>
		/// Timeban-command used by the admin
		/// </summary>
		private string strTimeBanCommand;
		/// <summary>
		/// ban-command used by the admin
		/// </summary>
		private string strBanCommand;
		/// <summary>
		/// unban-command used by the admin
		/// </summary>
		private string strUnBanCommand;
		/// <summary>
		/// globalban-command used by the admin
		/// </summary>
		private string strGlobalBanCommand;
		/// <summary>
		/// send returned ban information to all players or just asker
		/// </summary
		private enumBoolYesNo SendBanToAll;

		#endregion

		#region other
		
		enumBoolYesNo ebPluginDisabled;

		#endregion other

		public BanManager()
		{

			ebPBDisable = enumBoolYesNo.Yes;
			this.threadSafeCBanDic = new ThreadSafeCBanDic();
			this.threadSafeCleanPlayerDic = new ThreadSafeCleanPlayerDic();
			this.mySqlStringBuilder = new MySqlConnectionStringBuilder();
			this.intqport = 0;
			this.ebEmptyServerBanlist = enumBoolYesNo.Yes;
			this.ebEnableIngameAdmin = enumBoolYesNo.Yes;
			this.ebTestrun = enumBoolYesNo.No;
			this.ebPBDisable = enumBoolYesNo.No;
			this.ebEmptyServerPBBanlist = enumBoolYesNo.Yes;
			this.ebPrintKicksToConsole = enumBoolYesNo.Yes;

			this.servergroup = 0;
			this.ebDebugLevel = 0;
			this.strSlayCommand = "!s";
			this.strKickCommand = "!k";
			this.strRoundBanCommand = "!rb";
			this.strGlobalBanCommand = "!gb";
			this.strBanCommand = "!b";
			this.strUnBanCommand = "!ub";
			this.strTimeBanCommand = "!tb";
			//this.blPluginEnabled = false;
		}

		#endregion

		#region plugin details & settings

		public String GetPluginName()
		{
			return "Ban Manager";
		}

		public String GetPluginVersion()
		{
			return "1.1.0.0_beta";
		}

		public String GetPluginAuthor()
		{
			return "DaMagicWoBBeR";
		}

		public String GetPluginWebsite()
		{
			return "www.nrg-esports.de";
		}

		public String GetPluginDescription()
		{
			return @"
            <h2>Description</h2>
            <p><b>Banlist Manager</b> is a plugin based on MorpheusX(AUT) CRemoteBanlist V 1.0.0.11 (Website: http://www.phogue.net/forumvb/member.php?565-MorpheusX(AUT)). <br />
            Making use of a MySQL-Datebase, the plugin stores all its ban-information independent from the BF3-Server and its banlists, also providing some more fields to add information like Banning Admin and Server Name.<br />
            Bans can either be viewed or edited in the database directly. It implements its own Ingame Admin Commands. Please make use of it, if you want banning admin information in the database, bans taken via Procon cant provide the banning admin.<br />
            Please be aware: this is still an early release, so there might be some bugs within the code. Please report back if you encounter any errors!<br /></p>
            
            <h2>Settings</h2>
            <blockquote><h4>MySQL Host</h4>
			<p><i>Hostname or IP of your MySQL-Server</i></p>
			</blockquote>
            <blockquote><h4>MySQL Port</h4>
			<p><i>Port of your MySQL-Server</i></p>
			</blockquote>
            <blockquote><h4>MySQL Username</h4>
			<p><i>Username to identify with your MySQL-Server</i></p>
			</blockquote>
            <blockquote><h4>MySQL Password</h4>
			<p><i>Password to identify with your MySQL-Server</i></p>
			</blockquote>
            <blockquote><h4>MySQL Database</h4>
			<p><i>Name of the database to use</i></p>
			</blockquote>
            <blockquote><h4>Keep server-banlist empty?</h4>
			<p><i>If activated, the plugin issues a banList.clear and banList.save command after adding all bans in the list, thus keeping the local banlists clean.</i> <br><b>NOTE: ONLY DEACTIVATE FOR TESTPURPOSE!</b></p>
			</blockquote>
			<blockquote><h4>Test Run?</h4>
			<p><i>If activated, the plugin will only print a kick Notification to the plugin console, but will not kick the player who are in the banlist</i></p>
			</blockquote>
			<blockquote><h4>Keep server-PBbanlist empty?</h4>
			<p><i>If activated, PBbanlist will be cleared after adding the bans to the database </i><br><b>Note: Plugin will not add all PBBans if deactivated and there are more than about 1000 Entries. ONLY DEACTIVATE FOR TESTPURPOSE!</b></p>
			</blockquote>
			<blockquote><h4>disable Punkbuster support?</h4>
			<p><i>If set to yes, no Punkbuster Bans/Tempbans will be added to the database, but they are still working!</b></p>
			</blockquote>
            <blockquote><h4>Print kicked players to pluginconsole?</h4>
			<p><i>Prints a message to the pluginconsole, stating that a specific player has been found when kicking him.</i></p>
			</blockquote>
			<blockquote><h4>Server Group?</h4>
			<p><i>If 0 all bans will forced to every Gameserver, else only to this servergroup</i></p>
			</blockquote>
            <blockquote><h4>Debug level</h4>
			<p><i>0 is no debug,  1 = min 9 = verbose messages to plugin-console</i></p>
			</blockquote>
            <blockquote><h4>Enable Ingame Commands</h4>
			<p><i>TO GET ALL FEATURES OF THIS PLUGIN FORCE ALL BANS WITH THE INGAME COMMANDS OF THIS PLUGIN e.g. BANNING ADMIN</i><br><b>SYNTAXE: [command] [substring of the player] [optional: reason]</b></p>
			</blockquote>
			<blockquote><h4>Global Bancommand</h4>
			<p><i>If you uses more servergroups and wants to do a ban over all servers then use this command, it will set the servergroup to 0 for this ban</i></p>
			</blockquote>
			<blockquote><h4>Unban Command</h4>
			<p><i>Remove a ban from the database if the ban is global or corresponding to this servergroup. You need the excat name to unban. If a banentry is without the name in the database it cant be removed with this command</i><br><b>SYNTAXE: [command] [exact playername]</b></p>
			</blockquote>
            <h2>Changelog</h2>
			<h4>Version 1.0.3.1 </h4>
			<p>- fixed spamming FullDebug into PlugIn Console</br></p>
			<h4>Version 1.0.3.0 </h4>
			<p>- fixed a bug where ingame commands doesnt work</br>
			- fixed PunkBuster Problem where the wrong BanLength Type got written into database</br>
			- added option to disable Punkbuster Bans written into database</br>
			- added support for MySQL ODBC Driver 5.2</br></p>
			<h4>Version 1.0.2.0 </h4>
			<p>- compatible with Webpage</br>
			- add one more table to database</br>
			- change default value from eaguid to guid in database bantype</br>
			- change default value from 1 to 0 in database servergroup</br></p>
			<h4>Version 1.0.0.0 </h4>
			<p>- first release</p>
			<h2>Known Bugs</h2>
            <blockquote><h4>IP-Bans will not forced and not added to the Database maybe in a later version </h4>";
		}

		public void OnPluginLoaded(String strHostName, String strPort, String strPRoConVersion)
		{
			this.strHostName = strHostName;
			this.strPort = strPort;
			this.strPRoConVersion = strPRoConVersion;
		}

		public void OnPluginEnable()
		{
			#region add to connection string
			mySqlStringBuilder.Pooling = true;
			mySqlStringBuilder.MaximumPoolSize = 10;
			mySqlStringBuilder.MinimumPoolSize = 1;
			mySqlStringBuilder.ConnectionLifeTime = 30;
			
			#endregion

			this.RegisterEvents(this.GetType().Name, "OnGlobalChat", "OnTeamChat", "OnSquadChat", "OnListPlayers", "OnServerInfo", "OnLevelLoaded", "OnBanAdded", "OnBanRemoved", "OnBanList", "OnPunkbusterBanInfo", "OnPunkbusterPlayerInfo", "OnPlayerJoin");
			ExecuteCommand("procon.protected.pluginconsole.write", "^bBanList Manager: ^2Enabled!");
			ExecuteCommand("procon.protected.send", "serverInfo");
			ExecuteCommand("procon.protected.send", "banList.list");
			ExecuteCommand("procon.protected.send", "admin.listPlayers", "all");
			ExecuteCommand("procon.protected.tasks.add", "ProconPBList", "1", "90", "-1", "procon.protected.send", "punkBuster.pb_sv_command", "pb_sv_banlist");
			MySqlCheckDatabase();
			ebPluginDisabled = enumBoolYesNo.No;
			
		}

		public void OnPluginDisable()
		{
			ebPluginDisabled = enumBoolYesNo.Yes;
			ExecuteCommand("procon.protected.tasks.remove", "ProconPBLList");
			ExecuteCommand("procon.protected.tasks.remove", "banempty");
			ExecuteCommand("procon.protected.tasks.remove", "banload");
			ExecuteCommand("procon.protected.pluginconsole.write", "^bBanManager: ^1Disabled = :(");
			//TODO clear both dic classes
		}

		public List<CPluginVariable> GetDisplayPluginVariables()
		{
			List<CPluginVariable> lstReturn = new List<CPluginVariable>();

			lstReturn.Add(new CPluginVariable("1. MySQL Settings|MySQL Host", typeof(String), this.mySqlStringBuilder.Server));
			lstReturn.Add(new CPluginVariable("1. MySQL Settings|MySQL Port", typeof(int), (this.mySqlStringBuilder.Port)));
			lstReturn.Add(new CPluginVariable("1. MySQL Settings|MySQL Username", typeof(String), this.mySqlStringBuilder.UserID));
			lstReturn.Add(new CPluginVariable("1. MySQL Settings|MySQL Password", typeof(String), this.mySqlStringBuilder.Password));
			lstReturn.Add(new CPluginVariable("1. MySQL Settings|MySQL Database", typeof(String), this.mySqlStringBuilder.Database));
			lstReturn.Add(new CPluginVariable("1. MySQL Settings|Query Port Gameserver", typeof(int), this.intqport));

			lstReturn.Add(new CPluginVariable("2. Plugin Settings|Keep server-banlist empty?", typeof(enumBoolYesNo), ebEmptyServerBanlist));
			lstReturn.Add(new CPluginVariable("2. Plugin Settings|Keep server-PBbanlist empty?", typeof(enumBoolYesNo), ebEmptyServerPBBanlist));
			lstReturn.Add(new CPluginVariable("2. Plugin Settings|Test Run?", typeof(enumBoolYesNo), ebTestrun));
			lstReturn.Add(new CPluginVariable("2. Plugin Settings|Disable Support for PB-Bans?", typeof(enumBoolYesNo), ebPBDisable));
			lstReturn.Add(new CPluginVariable("2. Plugin Settings|Print kicked players to pluginconsole?", typeof(enumBoolYesNo), ebPrintKicksToConsole));
			lstReturn.Add(new CPluginVariable("2. Plugin Settings|Server Group", this.servergroup.GetType(), this.servergroup));
			lstReturn.Add(new CPluginVariable("2. Plugin Settings|Debug Level?", this.ebDebugLevel.GetType(), this.ebDebugLevel));

			lstReturn.Add(new CPluginVariable("3. Ingame Admin|Enable Ingame Commands?", typeof(enumBoolYesNo), this.ebEnableIngameAdmin));

			if (this.ebEnableIngameAdmin == enumBoolYesNo.Yes)
			{
				lstReturn.Add(new CPluginVariable("3. InGame Admin|Ingame Slaycommand", typeof(string), this.strSlayCommand));
				lstReturn.Add(new CPluginVariable("3. InGame Admin|Ingame Kickcommand", typeof(string), this.strKickCommand));
				lstReturn.Add(new CPluginVariable("3. InGame Admin|Ingame RoundBancommand", typeof(string), this.strRoundBanCommand));
				lstReturn.Add(new CPluginVariable("3. InGame Admin|Ingame TimeBancommand", typeof(string), this.strTimeBanCommand));
				lstReturn.Add(new CPluginVariable("3. InGame Admin|Ingame Bancommand", typeof(string), this.strBanCommand));
				lstReturn.Add(new CPluginVariable("3. InGame Admin|Ingame GlobalBancommand", typeof(string), this.strGlobalBanCommand));
				lstReturn.Add(new CPluginVariable("3. InGame Admin|Ingame UnBancommand", typeof(string), this.strUnBanCommand));
			}

			return lstReturn;
		}

		public List<CPluginVariable> GetPluginVariables()
		{
			List<CPluginVariable> lstReturn = new List<CPluginVariable>();

			lstReturn.Add(new CPluginVariable("MySQL Host", typeof(String), this.mySqlStringBuilder.Server));
			lstReturn.Add(new CPluginVariable("MySQL Port", typeof(int), this.mySqlStringBuilder.Port));
			lstReturn.Add(new CPluginVariable("MySQL Username", typeof(String), this.mySqlStringBuilder.UserID));
			lstReturn.Add(new CPluginVariable("MySQL Password", typeof(String), this.mySqlStringBuilder.Password));
			lstReturn.Add(new CPluginVariable("MySQL Database", typeof(String), this.mySqlStringBuilder.Database));
			lstReturn.Add(new CPluginVariable("Query Port Gameserver", typeof(int), this.intqport));
			
			lstReturn.Add(new CPluginVariable("Keep server-banlist empty?", typeof(enumBoolYesNo), ebEmptyServerBanlist));
			lstReturn.Add(new CPluginVariable("Test Run?", typeof(enumBoolYesNo), ebTestrun));
			lstReturn.Add(new CPluginVariable("Disable Support for PB-Bans?", typeof(enumBoolYesNo), ebPBDisable));
			lstReturn.Add(new CPluginVariable("Keep server-PBbanlist empty?", typeof(enumBoolYesNo), ebEmptyServerPBBanlist));
			lstReturn.Add(new CPluginVariable("Print kicked players to pluginconsole?", typeof(enumBoolYesNo), ebPrintKicksToConsole));
			lstReturn.Add(new CPluginVariable("Server Group", this.servergroup.GetType(), this.servergroup));
			lstReturn.Add(new CPluginVariable("Debug Level?", this.ebDebugLevel.GetType(), this.ebDebugLevel));
			lstReturn.Add(new CPluginVariable("Enable Ingame Commands?", typeof(enumBoolYesNo), this.ebEnableIngameAdmin));

			if (this.ebEnableIngameAdmin == enumBoolYesNo.Yes)
			{
				lstReturn.Add(new CPluginVariable("Ingame Slaycommand", typeof(string), this.strSlayCommand));
				lstReturn.Add(new CPluginVariable("Ingame Kickcommand", typeof(string), this.strKickCommand));
				lstReturn.Add(new CPluginVariable("Ingame RoundBancommand", typeof(string), this.strRoundBanCommand));
				lstReturn.Add(new CPluginVariable("Ingame TimeBancommand", typeof(string), this.strTimeBanCommand));
				lstReturn.Add(new CPluginVariable("Ingame Bancommand", typeof(string), this.strBanCommand));
				lstReturn.Add(new CPluginVariable("Ingame GlobalBancommand", typeof(string), this.strGlobalBanCommand));
				lstReturn.Add(new CPluginVariable("Ingame UnBancommand", typeof(string), this.strUnBanCommand));
				lstReturn.Add(new CPluginVariable("Send Information Ban To All", typeof(enumBoolYesNo), this.SendBanToAll));
			}

			return lstReturn;
		}

		public void SetPluginVariable(String strVariable, String strValue)
		{
			if (strVariable.CompareTo("MySQL Host") == 0)
			{

				if (String.IsNullOrEmpty(strValue)) this.PluginConsoleWrite("Error while parsing MySql Host! You have probably not entered a valid MySql Host!");
				else mySqlStringBuilder.Server = strValue;
			}
			else if (strVariable.CompareTo("MySQL Port") == 0)
			{
				int i;
				if (int.TryParse(strValue, out i) && (i > 0 && i <= 65535)) 
				{
					mySqlStringBuilder.Port = Convert.ToUInt32(i);
				}
				else
				{
					this.PluginConsoleWrite("Error while parsing MySql port! You have probably not entered a valid port!");
				}
			}
			else if (strVariable.CompareTo("MySQL Username") == 0)
			{
				if (String.IsNullOrEmpty(strValue)) this.PluginConsoleWrite("Error while parsing MySql Username! You have probably not entered a valid username!");
				else mySqlStringBuilder.UserID = strValue;
			}
			else if (strVariable.CompareTo("MySQL Password") == 0)
			{

				if (String.IsNullOrEmpty(strValue)) this.PluginConsoleWrite("Error while parsing MySql Password! You have probably not entered a valid password!");
				else mySqlStringBuilder.Password = strValue;
				
			}
			else if (strVariable.CompareTo("MySQL Database") == 0)
			{
				if (String.IsNullOrEmpty(strValue)) this.PluginConsoleWrite("Error while parsing MySql Database! You have probably not entered a valid Database!");
				else mySqlStringBuilder.Database = strValue;
			}
			else if (strVariable.CompareTo("Query Port Gameserver") == 0)
			{
				int i;
				if (int.TryParse(strValue, out i) && (i > 0 && i <= 65535)) 
				{ 
					this.intqport = i; 
				}
				else
				{
					this.PluginConsoleWrite("Error while parsing query port! You have probably not entered a valid query port!");
				}
			}
			else if (strVariable.CompareTo("Keep server-banlist empty?") == 0 && Enum.IsDefined(typeof(enumBoolYesNo), strValue))
			{
				this.ebEmptyServerBanlist = (enumBoolYesNo)Enum.Parse(typeof(enumBoolYesNo), strValue);
			}
			else if (strVariable.CompareTo("Enable Ingame Commands?") == 0 && Enum.IsDefined(typeof(enumBoolYesNo), strValue))
			{
				this.ebEnableIngameAdmin = (enumBoolYesNo)Enum.Parse(typeof(enumBoolYesNo), strValue);
			}
			else if (strVariable.CompareTo("Test Run?") == 0 && Enum.IsDefined(typeof(enumBoolYesNo), strValue))
			{
				this.ebTestrun = (enumBoolYesNo)Enum.Parse(typeof(enumBoolYesNo), strValue);
			}
			else if (strVariable.CompareTo("Keep server-PBbanlist empty?") == 0 && Enum.IsDefined(typeof(enumBoolYesNo), strValue))
			{
				this.ebEmptyServerPBBanlist = (enumBoolYesNo)Enum.Parse(typeof(enumBoolYesNo), strValue);
			}
			else if (strVariable.CompareTo("Disable Support for PB-Bans?") == 0 && Enum.IsDefined(typeof(enumBoolYesNo), strValue))
			{
				ebPBDisable = (enumBoolYesNo)Enum.Parse(typeof(enumBoolYesNo), strValue);
			}
			else if (strVariable.CompareTo("Print kicked players to pluginconsole?") == 0 && Enum.IsDefined(typeof(enumBoolYesNo), strValue))
			{
				this.ebPrintKicksToConsole = (enumBoolYesNo)Enum.Parse(typeof(enumBoolYesNo), strValue);
			}
			else if (strVariable.CompareTo("Server Group") == 0)
			{
				int i;
				if (int.TryParse(strValue, out i) && i >= 0) 
				{ 
					this.servergroup = i; 
				}
				else
				{
					this.PluginConsoleWrite("Error while parsing servergroup! Only servergroup >= 0 is valid! ");
				}
			}
			
			else if (strVariable.CompareTo("Debug Level?") == 0 && int.TryParse(strValue, out this.ebDebugLevel))
			{

			}
			else if (strVariable.CompareTo("Ingame Slaycommand") == 0)
			{
				this.strSlayCommand = strValue;
			}
			else if (strVariable.CompareTo("Ingame Kickcommand") == 0)
			{
				this.strKickCommand = strValue;
			}
			else if (strVariable.CompareTo("Ingame RoundBancommand") == 0)
			{
				this.strRoundBanCommand = strValue;
			}
			else if (strVariable.CompareTo("Ingame TimeBancommand") == 0)
			{
				this.strTimeBanCommand = strValue;
			}
			else if (strVariable.CompareTo("Ingame Bancommand") == 0)
			{
				this.strBanCommand = strValue;
			}
			else if (strVariable.CompareTo("Ingame GlobalBancommand") == 0)
			{
				this.strGlobalBanCommand = strValue;
			}
			else if (strVariable.CompareTo("Ingame UnBancommand") == 0)
			{
				this.strUnBanCommand = strValue;
			}
			else if (strVariable.CompareTo("Send Information Ban To All") == 0 && Enum.IsDefined(typeof(enumBoolYesNo), strValue))
			{
				this.SendBanToAll = (enumBoolYesNo)Enum.Parse(typeof(enumBoolYesNo), strValue);
			}
		}

		#endregion

		#region IPRoConPluginInterface

		public override void OnServerInfo(CServerInfo csiServerInfo)
		{
			if (ebPluginDisabled == enumBoolYesNo.Yes) return;
			ScaledDebugInfo(5, " OnServerInfo entered");
			this.csiServerInfo = csiServerInfo;
			MySqlInsertServerData();
		}

		public override void OnPlayerJoin(string strSoldierName)
		{
			if (ebPluginDisabled == enumBoolYesNo.Yes) return;
			this.ScaledDebugInfo(5, "OnPlayerJoin entered");

			//used for error messages from threadSafeCBanDic & threadSafeCleanPlayerDic classes

			string strErrorMsg = String.Empty;

			if (!String.IsNullOrEmpty(strSoldierName))
			{
				threadSafeCleanPlayerDic.Remove(strSoldierName, out strErrorMsg);
				threadSafeCBanDic.Remove(strSoldierName, out strErrorMsg);
				if (!String.IsNullOrEmpty(strErrorMsg)) 
				{
					ScaledDebugInfo(2, " something went wrong remove player from playerlists Error: " + strErrorMsg);
				}				
			}
		}
		
		public override void OnListPlayers(List<CPlayerInfo> cPlayerInfoList, CPlayerSubset cpsSubset)
		{
			ScaledDebugInfo(5, "OnListPlayers entered");
			
			if (cpsSubset.Subset == CPlayerSubset.PlayerSubsetType.All)
			{
				string strErrorMsg = String.Empty;
				
				if (threadSafeCleanPlayerDic.GetSize() > cPlayerInfoList.Count) threadSafeCleanPlayerDic.CheckForRemoveable(cPlayerInfoList);
				if (threadSafeCBanDic.GetSize() > cPlayerInfoList.Count + 16) threadSafeCBanDic.CheckForRemoveable(cPlayerInfoList);
				
				CRemoteBanInfo cRemoteBanInfo;

				foreach (CPlayerInfo cPlayerInfo in cPlayerInfoList)
				{
					if (ebPluginDisabled == enumBoolYesNo.Yes) return;
					if (!String.IsNullOrEmpty(cPlayerInfo.SoldierName))
					{
						
						if (!this.threadSafeCBanDic.Add(cPlayerInfo, out strErrorMsg))
						{
							ScaledDebugInfo(2, " could not add " + cPlayerInfo.SoldierName + " to CBanDic Error: " + strErrorMsg);
							continue;
						}
						
						// see if a player has been checked already, skipping him if hes "clean"
						if (!this.threadSafeCleanPlayerDic.Contains(cPlayerInfo.SoldierName, out strErrorMsg))
						{
							//TODO implement a faster method for checkplayerbanned
							cRemoteBanInfo = this.threadSafeCBanDic.GetPlayerInfo(cPlayerInfo.SoldierName, out strErrorMsg);

							if (cRemoteBanInfo != null && String.IsNullOrEmpty(strErrorMsg))
							{	
								//TODO take MySqlBanRequest
								int soldierid = MySqlPlayerRequest(cRemoteBanInfo, out strErrorMsg);
								if (soldierid == -2) 
								{
									ScaledDebugInfo(2, "something went wrong getting playerinformation Error:" + strErrorMsg);
									continue;
								} 
								else if ((soldierid == -1) && String.IsNullOrEmpty(strErrorMsg))
								{
										if (!String.IsNullOrEmpty(cRemoteBanInfo.strEAGUID) && !String.IsNullOrEmpty(cRemoteBanInfo.strPBGUID))
										{
											if (!this.threadSafeCleanPlayerDic.Add(cRemoteBanInfo, out strErrorMsg))
											{
												ScaledDebugInfo(2, " could not add " + cPlayerInfo.SoldierName + " to CleanPlayerDic Error: " + strErrorMsg);
											}
										}
										else if (!String.IsNullOrEmpty(strErrorMsg))
										{
											ScaledDebugInfo(2, " something went wrong getting playerinformation for " + cPlayerInfo.SoldierName + " Error: " + strErrorMsg);
										}
									
								}
								else if ((soldierid >= 0) && String.IsNullOrEmpty(strErrorMsg)) 
								{
									string reason = MySqlBanRequest(soldierid, out strErrorMsg);
									if (!String.IsNullOrEmpty(reason))
									{
										cRemoteBanInfo.strReason = reason;
										TakeAction(cRemoteBanInfo);
									}

								}

								else if (!String.IsNullOrEmpty(strErrorMsg))
								{
									ScaledDebugInfo(2, " something went wrong getting soldierid for " + cPlayerInfo.SoldierName + " Error: " + strErrorMsg);
								}
							}
							else if (!String.IsNullOrEmpty(strErrorMsg))
							{
								ScaledDebugInfo(2, " somthing went wrong getting cRemoteBanInfo object for " + cPlayerInfo.SoldierName + " Error: " + strErrorMsg);
							}
						}
						else if (!String.IsNullOrEmpty(strErrorMsg))
						{
							ScaledDebugInfo(2, " could not find cRemoteBanInfo object for " + cPlayerInfo.SoldierName + " Error: " + strErrorMsg);
						}
					}
					else 
					{
						ScaledDebugInfo(3, " soldiername is empty!");
					}
				}
			}
		}

		public override void OnPunkbusterPlayerInfo(CPunkbusterInfo cPunkbusterInfo)
		{
			if (ebPluginDisabled == enumBoolYesNo.Yes) return;
			this.ScaledDebugInfo(5, "OnPunkbusterPlayerInfo entered");
			string strErrorMsg = String.Empty;
			if (!String.IsNullOrEmpty(cPunkbusterInfo.SoldierName))
			{
				if (!this.threadSafeCBanDic.Add(cPunkbusterInfo, out strErrorMsg))
				{
					ScaledDebugInfo(2, " could not add " + cPunkbusterInfo.SoldierName + " to CBanDic Error: " + strErrorMsg);
				}
			}
		}

		public override void OnGlobalChat(string strSpeaker, string strMessage)
		{
			if (ebPluginDisabled == enumBoolYesNo.Yes) return;
			if (ebEnableIngameAdmin == enumBoolYesNo.Yes)
			{
				ScaledDebugInfo(5, "OnGlobalChat entered");

				// just filter all messages containing the bancommand and not being send by the server
				if (!String.IsNullOrEmpty(strSpeaker) && strSpeaker.ToLower() != "server")
				{
					strMessage.Trim();
					if (!String.IsNullOrEmpty(strMessage))
					{
						string[] ingamecommand = strMessage.Split();
						int elements = ingamecommand.GetLength(0);
						string strErrorMsg = String.Empty;
						if (elements >= 2)
						{ 
							#region checkunbancommand
							if (GetAccountPrivileges(strSpeaker).CanEditBanList && ingamecommand[0].ToLower() == strUnBanCommand.ToLower())
							{
								if (!String.IsNullOrEmpty(ingamecommand[1]))
								{
									
									MySqlRemoveBan(ingamecommand[1].Trim(), out strErrorMsg);
									ExecuteCommand("procon.protected.send", "admin.say", strErrorMsg, "player", strSpeaker);
									return;
								}
							}

							else
							{
								if (!GetAccountPrivileges(strSpeaker).CanEditBanList)
								{
									ExecuteCommand("procon.protected.send", "admin.say", "You have not enough privileges to unban !!!", "player", strSpeaker);
									return;
								}
							}
							#endregion

							#region checkbancommand
							if (GetAccountPrivileges(strSpeaker).CanPermanentlyBanPlayers && ingamecommand[0].ToLower() == strBanCommand.ToLower())
							{
								string chatreason = String.Empty;

								for (int i = 2; i < elements; i++)
								{
									chatreason += strSqlCleanup(ingamecommand[i].Trim()) + ' ';
									chatreason.TrimEnd(' ');
								}

								if (!String.IsNullOrEmpty(ingamecommand[1].Trim()))
								{
									int count;
									CRemoteBanInfo cRemoteBanInfo = this.threadSafeCBanDic.ContainsSubString(ingamecommand[1].Trim(), out count, out strErrorMsg);
									if (String.IsNullOrEmpty(strErrorMsg))
									{
										switch (count)
										{
											case 0:

												this.ExecuteCommand("procon.protected.send", "admin.say", ingamecommand[1] + " not found in playerlist!!!", "player", strSpeaker);
												return;

											case 1:
												cRemoteBanInfo.Length = TimeoutSubset.TimeoutSubsetType.Permanent;
												cRemoteBanInfo.strBanningAdmin = strSpeaker;
												cRemoteBanInfo.Type = BanType.eaguid;
												cRemoteBanInfo.TimeStamp = DateTime.UtcNow;
												if (!String.IsNullOrEmpty(chatreason)) cRemoteBanInfo.strReason = chatreason;
												else cRemoteBanInfo.strReason = "no reason set";
												
												if (MySqlAddBan(cRemoteBanInfo))
												{
													TakeAction(cRemoteBanInfo);
													ExecuteCommand("procon.protected.send", "admin.say", cRemoteBanInfo.strSoldierName + " got banned for " + chatreason, "all");
													return;
												}
												ExecuteCommand("procon.protected.send", "admin.say", ingamecommand[1] + " could not force ban", "player", strSpeaker);
												return;

											default:

												ExecuteCommand("procon.protected.send", "admin.say", ingamecommand[1] + " is not unique!!! ", "player", strSpeaker);
												return;
										}
									}
									else
									{
										this.ExecuteCommand("procon.protected.send", "admin.say", ingamecommand[1] + " something went wrong: " + strErrorMsg, "player", strSpeaker);
										return;
									}
								}
							}

							else
							{
								if (!GetAccountPrivileges(strSpeaker).CanPermanentlyBanPlayers)
								{
									ScaledDebugInfo(2, "something went wrong on bancommand: " + strErrorMsg);
									return;
								}
							}
							#endregion

							#region checkglobalbancommand
							if (GetAccountPrivileges(strSpeaker).CanPermanentlyBanPlayers && ingamecommand[0].ToLower() == strGlobalBanCommand.ToLower())
							{
								string chatreason = String.Empty;

								for (int i = 2; i < elements; i++)
								{
									chatreason += strSqlCleanup(ingamecommand[i].Trim()) + ' ';
									chatreason.TrimEnd(' ');
								}

								if (!String.IsNullOrEmpty(ingamecommand[1].Trim()))
								{
									int count;
									CRemoteBanInfo cRemoteBanInfo = this.threadSafeCBanDic.ContainsSubString(ingamecommand[1].Trim(), out count, out strErrorMsg);


									if (String.IsNullOrEmpty(strErrorMsg))
									{
										switch (count)
										{
											case 0:

												this.ExecuteCommand("procon.protected.send", "admin.say", ingamecommand[1] + " not found in playerlist!!!", "player", strSpeaker);
												return;

											case 1:

												cRemoteBanInfo.strBanningAdmin = strSpeaker;
												cRemoteBanInfo.Length = TimeoutSubset.TimeoutSubsetType.Permanent;
												cRemoteBanInfo.Type = BanType.eaguid;
												cRemoteBanInfo.TimeStamp = DateTime.UtcNow;
												if (!String.IsNullOrEmpty(chatreason)) cRemoteBanInfo.strReason = chatreason;
												else cRemoteBanInfo.strReason = "no reason set";
												
												//little trick to get ban as globalban
												int tmpservergroup = this.servergroup;
												this.servergroup = 0;
												
												if (MySqlAddBan(cRemoteBanInfo))
												{
													TakeAction(cRemoteBanInfo);
													ExecuteCommand("procon.protected.send", "admin.say", cRemoteBanInfo.strSoldierName + " got global banned for " + chatreason, "all");
													this.servergroup = tmpservergroup;
													return;
												}
												ExecuteCommand("procon.protected.send", "admin.say", ingamecommand[1] + " could not force ban", "player", strSpeaker);
												this.servergroup = tmpservergroup;
												return;

											default:

												ExecuteCommand("procon.protected.send", "admin.say", ingamecommand[1] + " is not unique!!! ", "player", strSpeaker);
												return;
										}
									}
									else
									{
										ScaledDebugInfo(2, "something went wrong on globalbancommand: " + strErrorMsg);
										return;
									}
								}
							}

							else if (!GetAccountPrivileges(strSpeaker).CanPermanentlyBanPlayers)
							{
								ScaledDebugInfo(2, "something went wrong on kickcommand: " + strErrorMsg);
								return;
							}
							#endregion

							#region checkroundbancommand
							if (GetAccountPrivileges(strSpeaker).CanTemporaryBanPlayers && ingamecommand[0].ToLower() == strRoundBanCommand.ToLower())
							{
								string chatreason = String.Empty;

								for (int i = 2; i < elements; i++)
								{
									chatreason += strSqlCleanup(ingamecommand[i].Trim()) + " ";
									chatreason.TrimEnd(' ');
								}

								if (!String.IsNullOrEmpty(ingamecommand[1]))
								{
									int count;
									CRemoteBanInfo cRemoteBanInfo = this.threadSafeCBanDic.ContainsSubString(ingamecommand[1].Trim(), out count, out strErrorMsg);

									if (String.IsNullOrEmpty(strErrorMsg))
									{
										switch (count)
										{
											case 0:

												this.ExecuteCommand("procon.protected.send", "admin.say", ingamecommand[1] + " not found in playerlist!!!", "player", strSpeaker);
												return;

											case 1:
												cRemoteBanInfo.Length = TimeoutSubset.TimeoutSubsetType.Round;
												cRemoteBanInfo.Type = BanType.eaguid;
												cRemoteBanInfo.strBanningAdmin = strSpeaker;
												cRemoteBanInfo.TimeStamp = DateTime.UtcNow;
												if (!String.IsNullOrEmpty(chatreason)) cRemoteBanInfo.strReason = chatreason;
												else cRemoteBanInfo.strReason = "no reason set";
												if (MySqlAddBan(cRemoteBanInfo))
												{
													TakeAction(cRemoteBanInfo);
													ExecuteCommand("procon.protected.send", "admin.say", cRemoteBanInfo.strSoldierName + " got roundbanned for " + chatreason, "all");
													return;
												}
												ExecuteCommand("procon.protected.send", "admin.say", ingamecommand[1] + " could not force roundban", "player", strSpeaker);
												return;

											default:

												ExecuteCommand("procon.protected.send", "admin.say", ingamecommand[1] + " is not unique!!!", "player", strSpeaker);
												return;
										}
									}
									else
									{
										ScaledDebugInfo(2, "something went wrong on roundbancommand: " + strErrorMsg);
										return;
									}
								}
							}

							else
							{
								if (!GetAccountPrivileges(strSpeaker).CanTemporaryBanPlayers)
								{
									ExecuteCommand("procon.protected.send", "admin.say", "You have not enough privileges to roundban!!!", "player", strSpeaker);
									return;
								}
							}
							#endregion

							#region checkkickcommand
							if (GetAccountPrivileges(strSpeaker).CanKickPlayers && ingamecommand[0].ToLower() == strKickCommand.ToLower())
							{
								string chatreason = String.Empty;
								
								for (int i = 2; i < elements; i++)
								{
									chatreason += strSqlCleanup(ingamecommand[i].Trim()) + " ";
									chatreason.TrimEnd(' ');
								}

								if (!String.IsNullOrEmpty(ingamecommand[1].Trim()))
								{
									int count;
									CRemoteBanInfo cRemoteBanInfo = this.threadSafeCBanDic.ContainsSubString(ingamecommand[1].Trim(), out count, out strErrorMsg);
									if (String.IsNullOrEmpty(strErrorMsg))
									{
										switch (count)
										{
											case 0:

												this.ExecuteCommand("procon.protected.send", "admin.say", ingamecommand[1] + " not found in playerlist!!!", "player", strSpeaker);
												return;

											case 1:

												TakeAction(cRemoteBanInfo);
												ExecuteCommand("procon.protected.send", "admin.say", cRemoteBanInfo.strSoldierName + " got kicked for " + chatreason, "all");
												return;

											default:

												ExecuteCommand("procon.protected.send", "admin.say", ingamecommand[1] + " is not unique!!! ", "player", strSpeaker);
												return;
										}
									}
									else
									{
										ScaledDebugInfo(2, "something went wrong on kickcommand: " + strErrorMsg);
										return;
									}
								}
							}
							else if (!GetAccountPrivileges(strSpeaker).CanKickPlayers)
							{
								ExecuteCommand("procon.protected.send", "admin.say", "You have not enough privileges to kick !!!", "player", strSpeaker);
								return;
							}
							#endregion

							#region checkslycommand
							if (GetAccountPrivileges(strSpeaker).CanKillPlayers && ingamecommand[0].ToLower() == strSlayCommand.ToLower())
							{
								string chatreason = String.Empty;

								for (int i = 2; i < elements; i++)
								{
									chatreason += strSqlCleanup(ingamecommand[i].Trim()) + " ";
								}

								if (!String.IsNullOrEmpty(ingamecommand[1].Trim()))
								{
									int count;
									CRemoteBanInfo cRemoteBanInfo = this.threadSafeCBanDic.ContainsSubString(ingamecommand[1].Trim(), out count, out strErrorMsg);

									if (String.IsNullOrEmpty(strErrorMsg))
									{
										switch (count)
										{
											case 0:

												this.ExecuteCommand("procon.protected.send", "admin.say", ingamecommand[1] + " not found in playerlist!!!", "player", strSpeaker);
												return;

											case 1:

												ExecuteCommand("procon.protected.send", "admin.killPlayer", cRemoteBanInfo.strSoldierName);
												ExecuteCommand("procon.protected.send", "admin.say", cRemoteBanInfo.strSoldierName + " got killed for " + chatreason, "all");
												return;

											default:

												ExecuteCommand("procon.protected.send", "admin.say", ingamecommand[1] + " is not unique!!! " + chatreason, "player", strSpeaker);
												return;
										}
									}
									else
									{
										ScaledDebugInfo(2, "something went wrong on slycommand: " + strErrorMsg);
										return;

									}
								}


							}
							else if (!GetAccountPrivileges(strSpeaker).CanKillPlayers)
							{
								ExecuteCommand("procon.protected.send", "admin.say", "You have not enough privileges to kill !!!", "player", strSpeaker);
								return;
							}
							#endregion

							#region checktimebancommand
							if (GetAccountPrivileges(strSpeaker).CanTemporaryBanPlayers && ingamecommand[0].ToLower() == strTimeBanCommand.ToLower())
							{

								string chatreason = String.Empty;

								if (!String.IsNullOrEmpty(ingamecommand[1].Trim()))
								{
									int count;
									CRemoteBanInfo cRemoteBanInfo = this.threadSafeCBanDic.ContainsSubString(ingamecommand[1].Trim(), out count, out strErrorMsg);

									if (cRemoteBanInfo != null && String.IsNullOrEmpty(strErrorMsg))
									{
										cRemoteBanInfo.TimeStamp = DateTime.UtcNow;
										if (elements >= 3)
										{
											if (!String.IsNullOrEmpty(ingamecommand[2]))
											{
												int bantime;

												#region check time specification
												if (ingamecommand[2].ToLower().EndsWith("w"))
												{
													string time = ingamecommand[2].Substring(0, ingamecommand[2].Length - 1);
													if (!String.IsNullOrEmpty(time))
													{
														if (int.TryParse(time, out bantime))
														{
															//604800 s == one week
															cRemoteBanInfo.Duration = cRemoteBanInfo.TimeStamp.AddDays(bantime * 7);
															for (int ii = 3; ii < ingamecommand.Length; ii++)
															{
																chatreason += ingamecommand[ii].Trim();

															}
														}
													}
												}
												else if (ingamecommand[2].ToLower().EndsWith("d"))
												{
													string time = ingamecommand[2].Substring(0, ingamecommand[2].Length - 1);
													if (!String.IsNullOrEmpty(time))
													{
														if (int.TryParse(time, out bantime))
														{
															cRemoteBanInfo.Duration = cRemoteBanInfo.TimeStamp.AddDays(bantime);
															for (int ii = 3; ii < ingamecommand.Length; ii++)
															{
																chatreason += ingamecommand[ii].Trim();

															}
														}
													}
												}
												else if (ingamecommand[2].ToLower().EndsWith("m"))
												{
													string time = ingamecommand[2].Substring(0, ingamecommand[2].Length - 1);
													if (!String.IsNullOrEmpty(time))
													{
														if (int.TryParse(time, out bantime))
														{
															//604800 s == one week
															cRemoteBanInfo.Duration = cRemoteBanInfo.TimeStamp.AddMinutes(bantime);
															for (int ii = 3; ii < ingamecommand.Length; ii++)
															{
																chatreason += ingamecommand[ii].Trim();
															}
														}
													}
												}
												else
												{
													string time = ingamecommand[2];
													if (int.TryParse(time, out bantime))
													{
														
														cRemoteBanInfo.Duration = cRemoteBanInfo.TimeStamp.AddSeconds(bantime * 3600);
													}
													else
													{
														for (int ii = 2; ii < ingamecommand.Length; ii++)
														{
															cRemoteBanInfo.Duration = cRemoteBanInfo.TimeStamp.AddSeconds(3600);			
															chatreason += ingamecommand[ii].Trim();

														}
													}
												}
												
												
												#endregion
											}
											else 
											{
												cRemoteBanInfo.Duration = cRemoteBanInfo.TimeStamp.AddSeconds(3600);
											}
										}
										else 
										{
											cRemoteBanInfo.Duration = cRemoteBanInfo.TimeStamp.AddSeconds(3600);
										}
										cRemoteBanInfo.strReason = chatreason;
										switch (count)
										{
											case 0:

												this.ExecuteCommand("procon.protected.send", "admin.say", ingamecommand[1] + " not found!!!", "player", strSpeaker);
												return;

											case 1:

												cRemoteBanInfo.strBanningAdmin = strSpeaker;
												cRemoteBanInfo.Type = BanType.eaguid;
												cRemoteBanInfo.Length = TimeoutSubset.TimeoutSubsetType.Seconds;
												if (MySqlAddBan(cRemoteBanInfo))
												{
													TakeAction(cRemoteBanInfo);
													ExecuteCommand("procon.protected.send", "admin.say", cRemoteBanInfo.strSoldierName + " got banned for " + cRemoteBanInfo.strReason, "all");
													return;
												}
												else
													ExecuteCommand("procon.protected.send", "admin.say", ingamecommand[1] + " ERROR: EAGuid emtpy. Try again ...", "player", strSpeaker);
												return;

											default:

												ExecuteCommand("procon.protected.send", "admin.say", ingamecommand[1] + " is not unique!!! ", "player", strSpeaker);
												return;
										}
									}
									else
									{
										if (!String.IsNullOrEmpty(strErrorMsg))
										{
											ScaledDebugInfo(2, "something went wrong on timebancommand: " + strErrorMsg);
										}
									}
								}
							}
							else

								if (!GetAccountPrivileges(strSpeaker).CanTemporaryBanPlayers)
								{
									ExecuteCommand("procon.protected.send", "admin.say", "You have not enough privileges to timeban !!!", "player", strSpeaker);
									return;
								}
							#endregion
						}
					}
				}
			}
		}

		public override void OnTeamChat(string strSpeaker, string strMessage, int iTeamID)
		{
			// doesnt matter what kind of chat the message was typed
			OnGlobalChat(strSpeaker, strMessage);
		}

		public override void OnSquadChat(string strSpeaker, string strMessage, int iTeamID, int iSquadID)
		{
			OnGlobalChat(strSpeaker, strMessage);
		}

		public override void OnBanAdded(CBanInfo cBanInfo)
		{
			if (ebPluginDisabled == enumBoolYesNo.Yes) return;
			
			ScaledDebugInfo(5, "OnBanAdded entered");
			
			CRemoteBanInfo cRemoteBanInfo = AddBanInformation(cBanInfo);
			
			#region removeban from serverbanlist
			if (MySqlAddBan(cRemoteBanInfo) && ebEmptyServerBanlist == enumBoolYesNo.Yes)
			{
				switch (cBanInfo.IdType)
				{
					case "pbguid":
						ExecuteCommand("procon.protected.tasks.add", cBanInfo.Guid, "0", "1", "1", "procon.protected.send", "punkBuster.pb_sv_command", "pb_sv_unbanguid " + cBanInfo.Guid);
						break;
					case "guid":
						ExecuteCommand("procon.protected.tasks.add", cBanInfo.Guid, "0", "1", "1", "procon.protected.send", "banList.remove", cBanInfo.IdType, cBanInfo.Guid);
						break;
					case "name":
						ExecuteCommand("procon.protected.tasks.add", cBanInfo.SoldierName, "0", "1", "1", "procon.protected.send", "banList.remove", cBanInfo.IdType, cBanInfo.SoldierName);
						break;
					default:
						break;
				}
				ScaledDebugInfo(3, cBanInfo.SoldierName + "/" + cBanInfo.Guid + " is now in database and removed from Serverbanlist");
			}
			else
			{
				if (ebEmptyServerBanlist == enumBoolYesNo.No)
				{
					ScaledDebugInfo(3, cBanInfo.SoldierName + "/" + cBanInfo.Guid + "/" + cBanInfo.IpAddress + " is now in database but not removed from Serverbanlist");
				}
			}
			#endregion
		}

		public override void OnBanList(List<CBanInfo> cBanInfoList)
		{
			this.ScaledDebugInfo(5, "OnBanList entered");
			this.ScaledDebugInfo(1, "Banlist with " + cBanInfoList.Count + " entries...");
			string strErrorMsg = String.Empty;
			if (ebEmptyServerBanlist == enumBoolYesNo.Yes)
			{
				foreach (CBanInfo cBanInfo in cBanInfoList)
				{
					if (ebPluginDisabled == enumBoolYesNo.Yes) return;
					
					this.ScaledDebugInfo(5, "OnBanList:: Guid: " + cBanInfo.Guid + " Name: " + cBanInfo.SoldierName + " IP: " + cBanInfo.IpAddress + " reason: " + cBanInfo.Reason + " BanType: " + cBanInfo.IdType);

					CRemoteBanInfo cRemoteBanInfo = AddBanInformation(cBanInfo);
					if (MySqlAddBan(cRemoteBanInfo))
					{
						if (cBanInfo.IdType.ToLower() == "guid") ExecuteCommand("procon.protected.send", "banList.remove", "guid", cBanInfo.Guid);
						if (cBanInfo.IdType.ToLower() == "name") ExecuteCommand("procon.protected.send", "banList.remove", "name", cBanInfo.SoldierName);
					}
				}
				ExecuteCommand("procon.protected.send", "banList.save");

			}
		}

		public override void OnLevelLoaded(String mapFileName, String Gamemode, int roundsPlayed, int roundsTotal)
		{
			if (ebPluginDisabled == enumBoolYesNo.Yes) return;
			ScaledDebugInfo(5, "OnLevelLoaded entered");

			string strMySqlCommand = "UPDATE " + this.mySqlStringBuilder.Database + ".bm_banlist SET ban_expired = 1 WHERE ban_length LIKE 'round';";

			MySqlWrite(strMySqlCommand);
		}

		public override void OnPunkbusterBanInfo(CBanInfo cBanInfo)
		{
			if (ebPluginDisabled == enumBoolYesNo.Yes) return;
			if (ebPBDisable == enumBoolYesNo.Yes) return;

			ScaledDebugInfo(5, "OnPunktbusterBanInfo entered");
			ExecuteCommand("procon.protected.tasks.remove", "banempty");
			ExecuteCommand("procon.protected.tasks.remove", "banload");

			CRemoteBanInfo cRemoteBanInfo = AddBanInformation(cBanInfo);
			if (cRemoteBanInfo != null)
			{
				if (MySqlAddBan(cRemoteBanInfo) && ebEmptyServerPBBanlist == enumBoolYesNo.Yes)
				{
					ExecuteCommand("procon.protected.tasks.add", cBanInfo.Guid, "0", "1", "1", "procon.protected.send", "punkBuster.pb_sv_command", "pb_sv_unbanguid " + cBanInfo.Guid);
					ScaledDebugInfo(1, cBanInfo.SoldierName + " is now in Database and removed on local banlist");
					ExecuteCommand("procon.protected.tasks.add", "banempty", "5", "1", "1", "procon.protected.send", "punkBuster.pb_sv_command", "pb_sv_banempty");
					ExecuteCommand("procon.protected.tasks.add", "banload", "5", "1", "1", "procon.protected.send", "punkBuster.pb_sv_command", "pb_sv_banload");
				}

				else
				{
					if (ebEmptyServerPBBanlist == enumBoolYesNo.No) ScaledDebugInfo(4, cBanInfo.SoldierName + " is now in Database but not removed from Serverbanlist");
					else ScaledDebugInfo(1, cBanInfo.SoldierName + " is NOT added to Database and not deleted from local banlist");
				}
			}
		}

		#endregion

		#region MySQL

		/// <summary>
		/// use for SQL Querys like update, insert, create
		/// </summary>
		/// <param name="mySqlCommand">Query String</param>
		/// <param name="mySqlParameter">used for parameters for example ?Variable</param>
		/// <returns>-1 on error else the Value changed rows</returns>
		private int MySqlWrite(string mySqlCommand, params MySqlParameter[] mySqlParameter)
		{
			ScaledDebugInfo(5, " MySqlQuery entered ");
			try
			{
				return MySqlHelper.ExecuteNonQuery(mySqlStringBuilder.ConnectionString, mySqlCommand, mySqlParameter);
			}
			catch (MySqlException ex)
			{
				//TODO add scaleddebuginfo
				ScaledDebugInfo(1, ex.ToString());
			}
			catch (Exception ex)
			{
				ScaledDebugInfo(2, ex.ToString());
			}
			return -1;
		}

		/// <summary>
		/// use this for reading data from database
		/// </summary>
		/// <param name="mySqlCommand">Query String</param>
		/// <param name="mySqlParameter">used for parameters for example ?Variable</param>
		/// <returns>null on error else a DataSet Object</returns>
		private MySqlDataReader MySqlRead(string mySqlCommand, params MySqlParameter[] mySqlParameter)
		{
			ScaledDebugInfo(5, " MySqlRead entered ");
			try
			{
				return MySqlHelper.ExecuteReader(mySqlStringBuilder.ConnectionString, mySqlCommand, mySqlParameter);

			}
			catch (MySqlException ex)
			{
				ScaledDebugInfo(1, ex.ToString());
			}
			catch (Exception ex)
			{
				ScaledDebugInfo(2, ex.ToString());
			}
			return null;
		}

		/// <summary>
		/// checks whether the needed tables already exists and create them if not
		/// </summary>
		private void MySqlCheckDatabase()
		{
			ScaledDebugInfo(5, " CheckDatabase entered");

			//TODO alten banlisten bearbeiten usw.
			#region create bm_banlist if not exists
			string strMySqlCommand = "CREATE TABLE IF NOT EXISTS " + this.mySqlStringBuilder.Database + @".bm_banlist (
									banID INT( 10 ) NOT NULL AUTO_INCREMENT,
									soldierID INT( 10 ) NOT NULL,
									ban_reason VARCHAR( 150 ) DEFAULT NULL,
                                    ban_admin VARCHAR( 1000 ) DEFAULT NULL,
                                    ban_typ ENUM('eaguid', 'pbguid', 'name') NOT NULL DEFAULT 'eaguid',
                                    ban_length ENUM('permanent', 'seconds', 'round') NOT NULL DEFAULT 'permanent',
                                    ban_duration DATETIME  DEFAULT NULL,
                                    ban_expired TINYINT( 1 ) DEFAULT 0,
                                    servergroup INT( 10) DEFAULT 0,
									timestamp TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
                                    PRIMARY KEY ( banID )
                                    ) ENGINE = INNODB;";
			if (MySqlWrite(strMySqlCommand) == -1)
			{
				ScaledDebugInfo(2, " something went wrong on creating bm_banlist");
			};
			#endregion

			#region create servertable if not exists
			strMySqlCommand = "CREATE TABLE IF NOT EXISTS " + this.mySqlStringBuilder.Database + @".bm_servergroup (
                                    serverip VARCHAR( 21 ) NOT NULL,
									servergroup INT( 10 ) NOT NULL DEFAULT 0,
                                    servername VARCHAR( 150 ) DEFAULT NULL,
                                    qport INT( 10 ) DEFAULT 0,
									PRIMARY KEY ( serverip )
                                    ) ENGINE = INNODB;";
			if (MySqlWrite(strMySqlCommand) == -1)
			{
				ScaledDebugInfo(2, " something went wrong on creating bm_servergroup");
			};
			#endregion servertable
			
			#region create playertable if not exists
			strMySqlCommand = "CREATE TABLE IF NOT EXISTS " + this.mySqlStringBuilder.Database + @".bm_soldiers (
                                    soldierID INT( 10 ) NOT NULL AUTO_INCREMENT,
									soldiername VARCHAR( 50 ) DEFAULT NULL,
                                    eaguid VARCHAR( 40 ) DEFAULT NULL,
									pbguid VARCHAR( 40 ) DEFAULT NULL,
									clantag VARCHAR( 15 ) DEFAULT NULL,
									country VARCHAR( 2 ) DEFAULT NULL,
									kick TINYINT( 1 ) DEFAULT 0,
									bancount INT( 11 ) DEFAULT 0,
                                    PRIMARY KEY ( soldierID )
                                    ) ENGINE = INNODB;";
			if (MySqlWrite(strMySqlCommand) == -1)
			{
				ScaledDebugInfo(2, " something went wrong on creating bm_soldiers");
			};
			#endregion

		}

		/// <summary>
		/// checks if player is already in database and returns the soldierID
		/// </summary>
		/// <param name="cRemoteBanInfo"></param>
		/// <param name="strErrorMsg"></param>
		/// <returns>soldierID if its in, -1 if not, -2 on error</returns>
		private int MySqlPlayerRequest(CRemoteBanInfo cRemoteBanInfo, out string strErrorMsg)
		{
			ScaledDebugInfo(5, "MySqlPlayerRequest entered");
			string strMySqlCommand = String.Empty;
			strErrorMsg = String.Empty;
			
			List<MySqlParameter> mySqlParameterList = new List<MySqlParameter>();
			strMySqlCommand = "SELECT DISTINCT soldierID FROM " + this.mySqlStringBuilder.Database + @".bm_soldiers WHERE ";
			bool sqlender = false;
			if (!String.IsNullOrEmpty(cRemoteBanInfo.strSoldierName))
			{
				mySqlParameterList.Add(new MySqlParameter("?Soldier", cRemoteBanInfo.strSoldierName));
				strMySqlCommand += "(soldiername LIKE ?Soldier)";
				sqlender = true;
			}
			if (!String.IsNullOrEmpty(cRemoteBanInfo.strEAGUID))
			{
				mySqlParameterList.Add(new MySqlParameter("?EAGuid", cRemoteBanInfo.strEAGUID));
				if (sqlender) strMySqlCommand += " OR (eaguid LIKE ?EAGuid)";
				else
				{
					strMySqlCommand += "(eaguid LIKE ?EAGuid)";
					sqlender = true;
				}
			}
			if (!String.IsNullOrEmpty(cRemoteBanInfo.strPBGUID))
			{
				mySqlParameterList.Add(new MySqlParameter("?PBGUID", cRemoteBanInfo.strPBGUID));
				if (sqlender) strMySqlCommand += " OR (pbguid LIKE ?PBGuid)";
				else
				{
					strMySqlCommand += "(pbguid LIKE ?PBGuid)";
					sqlender = true;
				}
			}
			
			using (MySqlDataReader dataReader = MySqlRead(strMySqlCommand, mySqlParameterList.ToArray()))
			{
				
				if (dataReader == null)
				{
					
					strErrorMsg = "something went wrong getting baninformation from database: dataReader is null";
					return -2;
				}
				if (!dataReader.HasRows)
				{
					strErrorMsg = String.Empty;
					return -1;
				}
				
				//TODO if more then one playerdata found clean database
				if (dataReader.HasRows)
				{
					dataReader.Read();
					strErrorMsg = String.Empty;
					return dataReader.GetInt32(0);
				}
			}
			strErrorMsg = "something went wrong after getting baninformation from database";
			return -2;
		}
		
		/// <summary>
		/// sql query player is banned
		/// </summary>
		/// <param name="SoldierName"></param>
		/// <param name="Guid"></param>
		/// <param name="PBGuid"></param>
		/// <returns>
		/// DaTaTable of the Request or Null
		/// </returns>
		private string MySqlBanRequest(int soldierID, out string strErrorMsg)
		{
			ScaledDebugInfo(5, "MySqlBanRequest entered");
			strErrorMsg = String.Empty;

			#region checktimeban

			string strMySqlCommand = "UPDATE " + this.mySqlStringBuilder.Database + @".bm_banlist SET ban_expired = 1 WHERE ban_length LIKE 'seconds' 
										AND (ban_duration <= ?DateTime );";
			List<MySqlParameter> mySqlParameterList = new List<MySqlParameter>();
			mySqlParameterList.Add(new MySqlParameter("?DateTime", DateTime.UtcNow.ToString("yyyy-MM-dd HH:mm:ss")));
			if (MySqlWrite(strMySqlCommand, mySqlParameterList.ToArray()) == -1)
			{
				ScaledDebugInfo(2, "something went wrong on checking timebanconditions");
			}

			#endregion

			
			mySqlParameterList = new List<MySqlParameter>();
			strMySqlCommand = "SELECT DISTINCT ban_reason FROM " + this.mySqlStringBuilder.Database + @".bm_banlist WHERE ( soldierID = ?soldierID )";
			strMySqlCommand += "AND (servergroup = 0 OR servergroup = ?servergroup ) AND (ban_expired = 0);";
			mySqlParameterList.Add(new MySqlParameter("?soldierID", soldierID));
			mySqlParameterList.Add(new MySqlParameter("?servergroup", this.servergroup));
			using (MySqlDataReader dataReader = MySqlRead(strMySqlCommand, mySqlParameterList.ToArray()))
			{
				if (dataReader == null)
				{
					strErrorMsg = "something went wrong getting baninformation from database: dataSet is null";
					return String.Empty;
				}
				if (!dataReader.HasRows)
				{
					strErrorMsg = String.Empty;
					return String.Empty;
				}
				//TODO if more than one reason found clean database
				if (dataReader.HasRows)
				{
					dataReader.Read();
					strErrorMsg = String.Empty;
					if (!String.IsNullOrEmpty(dataReader.GetString(0)))
					{
						return dataReader.GetString(0);
					}
					return "no reason set";
				}
			}

			strErrorMsg = " something else went wrong in MySqlBanRequest!!!";
			return String.Empty;
		}

		/// <summary>
		/// insert server information into mysql database
		/// </summary>
		private void MySqlInsertServerData()
		{
			ScaledDebugInfo(5, "MySqlInsertServerData entered");
			string strMySqlCommand = "INSERT INTO " + this.mySqlStringBuilder.Database + ".bm_servergroup (servergroup, servername, serverip, qport) VALUES (?sgroup, ?sname, ?sip, ?qp)ON DUPLICATE KEY UPDATE servergroup = ?sgroup, servername = ?sname;";

			List<MySqlParameter> mySqlParameterList = new List<MySqlParameter>();
			mySqlParameterList.Add(new MySqlParameter("?sgroup", this.servergroup));
			mySqlParameterList.Add(new MySqlParameter("?sname", csiServerInfo.ServerName));
			mySqlParameterList.Add(new MySqlParameter("?sip", csiServerInfo.ExternalGameIpandPort));
			mySqlParameterList.Add(new MySqlParameter("?qp", this.intqport));

			if (MySqlWrite(strMySqlCommand,mySqlParameterList.ToArray()) == -1)
			{
				ScaledDebugInfo(2, " something went wrong on writing serverdata into database");
			};
		}

		/// <summary>
		/// only add ban to banlist if it doesnt exist
		/// </summary>
		/// <param name="cRemoteBanInfo"></param>
		/// <returns>true if ban successful added or already exist else false</returns>
		private bool MySqlAddBan(CRemoteBanInfo cRemoteBanInfo)
		{
			this.ScaledDebugInfo(5, "MySqlAddBan entered");
			string strErrorMsg = String.Empty;
			string strReason = String.Empty;
			string strMySqlCommand = String.Empty;
			List<MySqlParameter> mySqlParameterList = new List<MySqlParameter>();

			#region CheckConditions
			if (cRemoteBanInfo.Type == BanType.name && String.IsNullOrEmpty(cRemoteBanInfo.strSoldierName))
			{
				ScaledDebugInfo(2, "could not force ban caus Bantype is NAME but name is null or empty");
				return false;
			}
			if (cRemoteBanInfo.Type == BanType.eaguid && String.IsNullOrEmpty(cRemoteBanInfo.strEAGUID))
			{
				ScaledDebugInfo(2, "could not force ban caus Bantype is EAGUID but EAGUID is null or empty");
				return false;
			}
			if (cRemoteBanInfo.Type == BanType.pbguid && String.IsNullOrEmpty(cRemoteBanInfo.strPBGUID))
			{
				ScaledDebugInfo(2, "could not force ban caus Bantype is PBGUID but PBGUID is null or empty");
				return false;
			}
			if ((DateTime.Compare(cRemoteBanInfo.Duration, cRemoteBanInfo.TimeStamp) <= 0) && (cRemoteBanInfo.Length == TimeoutSubset.TimeoutSubsetType.Seconds))
			{
				ScaledDebugInfo(2, "could not force ban because BanLengthtype is time but time <= 0");
				return false;
			}

			this.ScaledDebugInfo(3, "Passed all Checks in AddBan");
			#endregion CheckConditions

			int soldierid = MySqlPlayerRequest(cRemoteBanInfo, out strErrorMsg);

			if (!String.IsNullOrEmpty(strErrorMsg))
			{
				ScaledDebugInfo(2, strErrorMsg);
				return false;
			}
			else if (soldierid == -1)
			{
				strMySqlCommand = "INSERT INTO " + this.mySqlStringBuilder.Database + ".bm_soldiers (soldiername, eaguid, pbguid, country, clantag) VALUES (?soldiername, ?eaguid, ?pbguid, ?country, ?clantag);";
				mySqlParameterList = new List<MySqlParameter>();
				mySqlParameterList.Add(new MySqlParameter("?soldiername", cRemoteBanInfo.strSoldierName));
				mySqlParameterList.Add(new MySqlParameter("?eaguid", cRemoteBanInfo.strEAGUID));
				mySqlParameterList.Add(new MySqlParameter("?pbguid", cRemoteBanInfo.strPBGUID));
				mySqlParameterList.Add(new MySqlParameter("?country", cRemoteBanInfo.strCountry));
				mySqlParameterList.Add(new MySqlParameter("?clantag", cRemoteBanInfo.strClanTag));

				MySqlWrite(strMySqlCommand, mySqlParameterList.ToArray());

				soldierid = MySqlPlayerRequest(cRemoteBanInfo, out strErrorMsg);
				if (!String.IsNullOrEmpty(strErrorMsg)) 
				{
					ScaledDebugInfo(2, strErrorMsg);
					return false;
				}

			}
			if (soldierid >= 0)
			{
				strReason = MySqlBanRequest(soldierid, out strErrorMsg);

				if (!String.IsNullOrEmpty(strErrorMsg))
				{
					ScaledDebugInfo(2, strErrorMsg);
					return false;
				}
				else if (String.IsNullOrEmpty(strReason))
				{
					mySqlParameterList.Clear();

					strMySqlCommand = "INSERT INTO " + this.mySqlStringBuilder.Database + @".bm_banlist  (soldierID, ban_reason, ban_admin, ban_typ, ban_length, ban_duration, servergroup, timestamp)
										VALUES (?soldierID, ?ban_reason, ?ban_admin, ?ban_typ, ?ban_length, ?ban_duration, ?servergroup, ?timestamp)";
					mySqlParameterList.Add(new MySqlParameter("?soldierID", soldierid));
					mySqlParameterList.Add(new MySqlParameter("?ban_reason", cRemoteBanInfo.strReason));
					mySqlParameterList.Add(new MySqlParameter("?ban_admin", cRemoteBanInfo.strBanningAdmin));
					mySqlParameterList.Add(new MySqlParameter("?servergroup", this.servergroup.ToString()));
					mySqlParameterList.Add(new MySqlParameter("?ban_typ", cRemoteBanInfo.Type.ToString()));
					mySqlParameterList.Add(new MySqlParameter("?ban_length", cRemoteBanInfo.Length.ToString().ToLower()));
					mySqlParameterList.Add(new MySqlParameter("?ban_duration", cRemoteBanInfo.Duration.ToString("yyyy-MM-dd HH:mm:ss")));
					mySqlParameterList.Add(new MySqlParameter("?timestamp", cRemoteBanInfo.TimeStamp.ToString("yyyy-MM-dd HH:mm:ss")));
					
					MySqlWrite(strMySqlCommand, mySqlParameterList.ToArray());
					
					return true;
				}
				else if (!String.IsNullOrEmpty(strReason))
				{
					return true;
				}
			}
			return false;
		}

		/// <summary>
		/// 
		/// </summary>
		/// <param name="strSoldierName">name of the player</param>
		/// <param name="strMsg">message if successfull or not (for ingame message)</param>
		/// <returns>true on success else some</returns>
		private bool MySqlRemoveBan(string strSoldierName, out string strErrorMsg)
		{
			this.ScaledDebugInfo(5, "RemoveBan entered");
			strErrorMsg = String.Empty;

			int soldierid = MySqlPlayerRequest(new CRemoteBanInfo((strSoldierName)),out strErrorMsg);
			if (soldierid == -2) 
			{
				ScaledDebugInfo(2, "something went wrong on MySqlRemoveBan Error: " + strErrorMsg);
				return false;
			}
			if (soldierid == -1 && String.IsNullOrEmpty(strErrorMsg)) 
			{
				strErrorMsg = strSoldierName + " not found in database";
				return false;
			}
			if (soldierid > -1 && String.IsNullOrEmpty(strErrorMsg))
			{
				string strMySqlCommand = "DELETE FROM " + this.mySqlStringBuilder.Database + @".bm_banlist WHERE (soldierID LIKE ?soldierid AND servergroup LIKE (0 OR ?servergroup))";
				List<MySqlParameter> mySqlParameterList = new List<MySqlParameter>();
				mySqlParameterList.Add(new MySqlParameter("?soldierid", soldierid));
				mySqlParameterList.Add(new MySqlParameter("?servergroup", this.servergroup));
				return true;
			}

			return false;
		}

		private void MySqlForceHomePageKicks() 
		{
			string strMySqlCommand = "SELECT soldierID, soldiername FROM " + this.mySqlStringBuilder.Database + ".bm_soldiers WHERE kick = 1;";
			using (MySqlDataReader mySqlDataReader = MySqlRead(strMySqlCommand))
			{
				if (mySqlDataReader == null) return;
				if (mySqlDataReader.FieldCount == 0) return;
				while (mySqlDataReader.Read()) 
				{ 
					string strErrorMsg = String.Empty;
					int soldierid = mySqlDataReader.GetInt32(0);
					CRemoteBanInfo cRemoteBanInfo = threadSafeCBanDic.GetPlayerInfo(mySqlDataReader.GetString(1), out strErrorMsg);
					if (cRemoteBanInfo != null && String.IsNullOrEmpty(strErrorMsg))
					{
						TakeAction(cRemoteBanInfo);
						
						List<MySqlParameter> mySqlParameterList = new List<MySqlParameter>();
						strMySqlCommand = "UPDATE " + this.mySqlStringBuilder.Database + ".bm_soldiers SET kick = ?kick WHERE soldierID = ?soldierid;";
						mySqlParameterList.Add(new MySqlParameter("?kick", 0));
						mySqlParameterList.Add(new MySqlParameter("?soldierid", soldierid));
						
						int i = MySqlWrite(strMySqlCommand, mySqlParameterList.ToArray());
					}
				}
			
			
			}
		}
		
		#endregion

		#region other methods
		

		private CRemoteBanInfo AddBanInformation(CBanInfo cBanInfo)
		{

			string strErrorMsg = String.Empty;
			CRemoteBanInfo cRemoteBanInfo = null;
			if (!String.IsNullOrEmpty(cBanInfo.SoldierName))
			{
				
				cRemoteBanInfo = this.threadSafeCBanDic.GetPlayerInfo(cBanInfo.SoldierName, out strErrorMsg);
				
				if (cRemoteBanInfo == null)
				{
					return cRemoteBanInfo = new CRemoteBanInfo(cBanInfo);
				}
				else if (!String.IsNullOrEmpty(strErrorMsg))
				{
					return null;
				}
			}
			if (!String.IsNullOrEmpty(cBanInfo.Guid) && cRemoteBanInfo == null)
			{
				cRemoteBanInfo = this.threadSafeCBanDic.SearchGUID(cBanInfo.Guid, out strErrorMsg);
				if (cRemoteBanInfo == null)
				{
					return cRemoteBanInfo = new CRemoteBanInfo(cBanInfo);
				}
				else if (!String.IsNullOrEmpty(strErrorMsg))
				{
					return null;
				}
			}

			cRemoteBanInfo.strReason = cBanInfo.Reason.Replace("BC2! \"","");
			cRemoteBanInfo.strReason = cRemoteBanInfo.strReason.Replace("[Admin Decision]", "");
			if (String.Compare(cBanInfo.IdType, "pbguid") == 0)
			{
				cRemoteBanInfo.Type = BanType.pbguid;
				cRemoteBanInfo.strPBGUID = cBanInfo.Guid;
			}
			else
			{
				if (String.Compare(cBanInfo.IdType, "name") == 0 || String.Compare(cBanInfo.IdType, "persona") == 0) 
				{ cRemoteBanInfo.Type = BanType.name;
					if (!String.IsNullOrEmpty(cBanInfo.Guid))
					{
						if (cBanInfo.Guid.Length == 32) cRemoteBanInfo.strPBGUID = cBanInfo.Guid;
						else if (cBanInfo.Guid.Length == 35) cRemoteBanInfo.strEAGUID = cBanInfo.Guid;
					}
				
				}
				
				if (String.Compare(cBanInfo.IdType, "guid") == 0)
				{
					cRemoteBanInfo.Type = BanType.eaguid;
					cRemoteBanInfo.strEAGUID = cBanInfo.Guid;
				}
			}
			cRemoteBanInfo.Length = cBanInfo.BanLength.Subset;
			cRemoteBanInfo.TimeStamp = DateTime.UtcNow;
			if (cRemoteBanInfo.Length == TimeoutSubset.TimeoutSubsetType.Seconds) cRemoteBanInfo.Duration = cRemoteBanInfo.TimeStamp.AddSeconds(cBanInfo.BanLength.Seconds);
			return cRemoteBanInfo;
		}
	
		/// <summary>
		/// execute a kick
		/// </summary>
		/// <param name="name">name of the player to remove</param>
		/// <param name="reason">reason shown to the player</param>
		private void TakeAction(CRemoteBanInfo cRemoteBanInfo)
		{
			ScaledDebugInfo(5, "TakeAction entered");
			if (this.ebTestrun == enumBoolYesNo.Yes)
			{
				PluginConsoleWrite("Testmode: Player" + cRemoteBanInfo.strSoldierName + " would have been kicked for " + cRemoteBanInfo.strReason);
			}
			else
			{
				switch (cRemoteBanInfo.Length)
				{
					case TimeoutSubset.TimeoutSubsetType.Permanent:
						{

							this.ExecuteCommand("procon.protected.send", "admin.kickPlayer", cRemoteBanInfo.strSoldierName, "YOUR ARE BANNED FOR: " + cRemoteBanInfo.strReason);
							if (ebPrintKicksToConsole == enumBoolYesNo.Yes) ScaledDebugInfo(0, "Kicked " + cRemoteBanInfo.strSoldierName + " for " + cRemoteBanInfo.strReason + " (permanent)");
							break;
						}
					case TimeoutSubset.TimeoutSubsetType.Seconds:
						{
							this.ExecuteCommand("procon.protected.send", "admin.kickPlayer", cRemoteBanInfo.strSoldierName, "YOUR ARE TIMEBANNED FOR: " + cRemoteBanInfo.strReason);
							if (ebPrintKicksToConsole == enumBoolYesNo.Yes) ScaledDebugInfo(0, "Kicked " + cRemoteBanInfo.strSoldierName + " for " + cRemoteBanInfo.strReason + " (time)");
							break;
						}
					case TimeoutSubset.TimeoutSubsetType.Round:
						{
							this.ExecuteCommand("procon.protected.send", "admin.kickPlayer", cRemoteBanInfo.strSoldierName, "YOUR ARE ROUNDBANNED FOR: " + cRemoteBanInfo.strReason);
							if (ebPrintKicksToConsole == enumBoolYesNo.Yes) ScaledDebugInfo(0, "Kicked " + cRemoteBanInfo.strSoldierName + " for " + cRemoteBanInfo.strReason + " (round)");
							break;
						}
					default:
						{
							this.ExecuteCommand("procon.protected.send", "admin.kickPlayer", cRemoteBanInfo.strSoldierName, "YOUR ARE KICKED FOR: " + cRemoteBanInfo.strReason);
							if (ebPrintKicksToConsole == enumBoolYesNo.Yes) ScaledDebugInfo(0, "Kicked " + cRemoteBanInfo.strSoldierName + " for " + cRemoteBanInfo.strReason);
							break;
						}
				}
			}
		}

		public void ScaledDebugInfo(int debuglevel, string DebugMessage)
		{
			if (debuglevel <= ebDebugLevel)
			{
				PluginConsoleWrite("DebugLevel: " + debuglevel + DebugMessage);
			}
		}

		/// <summary>
		/// write a message to the plugin-console
		/// </summary>
		/// <param name="message">message to display</param>
		private void PluginConsoleWrite(String message)
		{
			String line = String.Format("^b^8BanManager^0:^n {0}", message);
			this.ExecuteCommand("procon.protected.pluginconsole.write", line);
		}

		private string strSqlCleanup(String strSqlMessage)
		{
			if (String.IsNullOrEmpty(strSqlMessage)) return "";
			this.ScaledDebugInfo(6, "Ban reason Cleanup - Entered");

			// Replace invalid characters with empty strings.
			strSqlMessage.Trim();
			return Regex.Replace(strSqlMessage, "[\\/]", "");
		}
		
		public bool IsNumeric(System.Object Expression)
		{
			if (Expression == null || Expression is DateTime)
				return false;

			if (Expression is Int16 || Expression is Int32 || Expression is Int64 || Expression is Decimal || Expression is Single || Expression is Double || Expression is Boolean)
				return true;

			try
			{
				if (Expression is string)
					Double.Parse(Expression as string);
				else
					Double.Parse(Expression.ToString());
				return true;
			}
			catch { } // just dismiss errors but return false
			return false;
		}
								
		#endregion

		#region own classes & enums

		/// <summary>
		/// enumeration for setting the type of a ban
		/// </summary>
		public enum BanType { name, eaguid, pbguid }
		
		/// <summary>
		/// holds additional information about a ban, designed to be stored in a MySQL-database
		/// </summary>
		public class CRemoteBanInfo
		{

			/// <summary>
			/// ClanTag of the Player (not provided by ProCon and EA at the moment)
			/// </summary>
			public String strClanTag;
			/// <summary>
			/// SoldieName
			/// </summary>
			public String strSoldierName;
			/// <summary>
			/// EA GUID of the banned player
			/// </summary>
			public String strEAGUID;
			/// <summary>
			/// PB GUID of the banned player
			/// </summary>
			public String strPBGUID;
			/// <summary>
			/// reason for banning
			/// </summary>
			public String strReason;
			/// <summary>
			/// name of the admin issueing the ban
			/// </summary>
			public String strBanningAdmin;
			/// <summary>
			/// type of the ban
			/// </summary>
			public BanType Type;
			/// <summary>
			/// length of the ban
			/// </summary>
			public TimeoutSubset.TimeoutSubsetType Length;
			/// <summary>
			/// duration of the ban (timestamp)
			/// </summary>
			public DateTime Duration;
			/// <summary>
			/// timestamp of the ban-creation
			/// </summary>
			public DateTime TimeStamp;
			/// <summary>
			/// timestamp of the ban-creation
			/// </summary>
			public String strCountry;
			/// <summary>
			/// create a new RemoteBanInfo-object and initialise all variables with empty values
			/// </summary>

			public CRemoteBanInfo()
			{
				this.strClanTag = String.Empty;
				this.strSoldierName = String.Empty;
				this.strEAGUID = String.Empty;
				this.strPBGUID = String.Empty;
				this.strReason = String.Empty;
				this.strBanningAdmin = String.Empty;
				this.Length = TimeoutSubset.TimeoutSubsetType.None;
				this.strCountry = String.Empty;
			}

			public CRemoteBanInfo(string strSoldierName) 
			{
				this.strSoldierName = strSoldierName;
			}

			public CRemoteBanInfo(CBanInfo cBanInfo)
			{
				this.strSoldierName = cBanInfo.SoldierName;
				this.strReason = cBanInfo.Reason;
				this.strReason = this.strReason.Replace("BC2! \"","");
				this.strReason = this.strReason.Replace("[Admin Decision]", "");
				this.strBanningAdmin = String.Empty;
				if (String.Compare(cBanInfo.IdType, "pbguid") == 0)
				{
					this.Type = BanType.pbguid;
					this.strPBGUID = cBanInfo.Guid;
				}
				else if (String.Compare(cBanInfo.IdType, "name") == 0 || String.Compare(cBanInfo.IdType, "persona") == 0)
				{
					this.Type = BanType.name;
					if (!String.IsNullOrEmpty(cBanInfo.Guid))
					{
						if (cBanInfo.Guid.Length == 32) this.strPBGUID = cBanInfo.Guid;
						else if (cBanInfo.Guid.Length == 35) this.strEAGUID = cBanInfo.Guid;
					}
				}
				else if (String.Compare(cBanInfo.IdType, "guid") == 0)
				{
					this.Type = BanType.eaguid;
					this.strEAGUID = cBanInfo.Guid;
				}
				this.Length = cBanInfo.BanLength.Subset;
				this.TimeStamp = DateTime.UtcNow;
				if (cBanInfo.BanLength.Subset == TimeoutSubset.TimeoutSubsetType.Seconds) this.Duration = this.TimeStamp.AddSeconds(cBanInfo.BanLength.Seconds);
				
			}

			public CRemoteBanInfo(CPlayerInfo cPlayerInfo) 
			{
				this.strClanTag = cPlayerInfo.ClanTag;
				this.strSoldierName = cPlayerInfo.SoldierName;
				this.strEAGUID = cPlayerInfo.GUID;
			}
		}
		
		private class ThreadSafeCBanDic
		{
			private Dictionary<string, CRemoteBanInfo> dicCRemoteBanInfo;
			private ReaderWriterLock rwLock;
			public ThreadSafeCBanDic()
			{
				this.rwLock = new ReaderWriterLock();
				this.rwLock.AcquireWriterLock(new TimeSpan(1000));
				try
				{
					this.dicCRemoteBanInfo = new Dictionary<string, CRemoteBanInfo>();
				}
				catch (Exception ex)
				{
					//TODO Fehler ausgeben
				}
				finally
				{
					this.rwLock.ReleaseWriterLock();
				}

			}

			/// <summary>
			/// removes a player and the corresponding CRemoteBanInfoObject from the Dictionary (thread safe)
			/// </summary>
			/// <param name="strSoldierName"></param>
			/// <param name="strErrorMsg"></param>
			/// <returns>true if successful or not in dictionary, false only on error</returns>
			public bool Remove(string strSoldierName, out string strErrorMsg)
			{
				this.rwLock.AcquireWriterLock(new TimeSpan(1000));
				strErrorMsg = String.Empty;
				try
				{
					if (this.dicCRemoteBanInfo.ContainsKey(strSoldierName))
					{
						this.dicCRemoteBanInfo.Remove(strSoldierName);
						return true;
					}
					return true;
				}
				catch (Exception ex)
				{
					strErrorMsg = ex.Message;
				}
				finally
				{
					this.rwLock.ReleaseWriterLock();
				}
				if (String.IsNullOrEmpty(strErrorMsg)) strErrorMsg = "something went wrong!";
				return false;
			}

			public bool Add(string strSoldierName, out string strErrorMsg)
			{
				this.rwLock.AcquireReaderLock(new TimeSpan(1000));
				strErrorMsg = String.Empty;
				try
				{
					if (this.dicCRemoteBanInfo.ContainsKey(strSoldierName))
					{
						return true;
					}
					else
					{
						LockCookie lockCookie = this.rwLock.UpgradeToWriterLock(new TimeSpan(1000));

						try
						{
							CRemoteBanInfo cRemoteBanInfo = new CRemoteBanInfo(strSoldierName);
							this.dicCRemoteBanInfo.Add(strSoldierName, cRemoteBanInfo);
						}
						catch (Exception ex)
						{

						}
						finally
						{
							this.rwLock.DowngradeFromWriterLock(ref lockCookie);
						}
						return true;
					}
				}
				catch (Exception ex)
				{
					strErrorMsg = ex.Message;
				}
				finally
				{
					this.rwLock.ReleaseReaderLock();
				}
				if (String.IsNullOrEmpty(strErrorMsg)) strErrorMsg = "something went wrong!";
				return false;
			}

			/// <summary>
			/// add or update a CRemoteBanInfoObject information in a dictionary (is thread safe)
			/// </summary>
			/// <param name="cPlayerInfo"></param>
			/// <returns>true if CPlayerInfo.SoldierName is succesfull added/updated/found else false</returns>
			public bool Add(CPlayerInfo cPlayerInfo, out string strErrorMsg)
			{
				strErrorMsg = String.Empty;
				if (String.IsNullOrEmpty(cPlayerInfo.SoldierName)) return false;
				this.rwLock.AcquireReaderLock(new TimeSpan(1000));
				try
				{
					if (this.dicCRemoteBanInfo.ContainsKey(cPlayerInfo.SoldierName))
					{
						if ((String.IsNullOrEmpty(this.dicCRemoteBanInfo[cPlayerInfo.SoldierName].strEAGUID) && !String.IsNullOrEmpty(cPlayerInfo.GUID)) ||
							(String.IsNullOrEmpty(this.dicCRemoteBanInfo[cPlayerInfo.SoldierName].strClanTag) && !String.IsNullOrEmpty(cPlayerInfo.ClanTag)))
						{
							LockCookie lockCookie = this.rwLock.UpgradeToWriterLock(new TimeSpan(1000));
							try
							{
								
								if (String.IsNullOrEmpty(this.dicCRemoteBanInfo[cPlayerInfo.SoldierName].strClanTag) && !String.IsNullOrEmpty(cPlayerInfo.ClanTag))
								{
									this.dicCRemoteBanInfo[cPlayerInfo.SoldierName].strClanTag = cPlayerInfo.ClanTag;
								}
								if (String.IsNullOrEmpty(this.dicCRemoteBanInfo[cPlayerInfo.SoldierName].strEAGUID) && !String.IsNullOrEmpty(cPlayerInfo.GUID))
								{
									this.dicCRemoteBanInfo[cPlayerInfo.SoldierName].strEAGUID = cPlayerInfo.GUID;
								}
								return true;
							}
							catch (Exception ex)
							{
								strErrorMsg = ex.Message;
							}
							finally
							{
								this.rwLock.DowngradeFromWriterLock(ref lockCookie);
							}
							if (String.IsNullOrEmpty(strErrorMsg)) strErrorMsg = "something went wrong!";
							return false;
						}
						return true;
					}
					else
					{
						LockCookie lockCookie = this.rwLock.UpgradeToWriterLock(new TimeSpan(1000));
						try
						{
							CRemoteBanInfo cRemoteBanInfo = new CRemoteBanInfo();
							cRemoteBanInfo.strClanTag = cPlayerInfo.ClanTag;
							cRemoteBanInfo.strSoldierName = cPlayerInfo.SoldierName;
							cRemoteBanInfo.strEAGUID = cPlayerInfo.GUID;
							this.dicCRemoteBanInfo.Add(cPlayerInfo.SoldierName, cRemoteBanInfo);
							return true;
						}
						catch (Exception ex)
						{
							strErrorMsg = ex.Message;
						}
						finally
						{
							this.rwLock.DowngradeFromWriterLock(ref lockCookie);
						}
						if (String.IsNullOrEmpty(strErrorMsg)) strErrorMsg = "something went wrong!";
						return false;
					}
				}
				catch (Exception ex)
				{
					strErrorMsg = ex.Message;
				}
				finally
				{
					this.rwLock.ReleaseReaderLock();
				}
				if (String.IsNullOrEmpty(strErrorMsg)) strErrorMsg = "something went wrong!";
				return false;
			}

			/// <summary>
			/// add or update a CRemoteBanInfoObject information in a dictionary (is thread safe)
			/// </summary>
			/// <param name="cPunkbusterInfo"></param>
			/// <returns>true if CPunkbusterInfo.SoldierName is succesfull added/updated/found else false</returns>
			public bool Add(CPunkbusterInfo cPunkbusterInfo, out string strErrorMsg)
			{
				strErrorMsg = String.Empty;
				if (String.IsNullOrEmpty(cPunkbusterInfo.SoldierName)) return false;
				this.rwLock.AcquireReaderLock(new TimeSpan(1000));
				
				try
				{
					if (this.dicCRemoteBanInfo.ContainsKey(cPunkbusterInfo.SoldierName))
					{
						if ((String.IsNullOrEmpty(this.dicCRemoteBanInfo[cPunkbusterInfo.SoldierName].strPBGUID) && !String.IsNullOrEmpty(cPunkbusterInfo.GUID)) ||
							(String.IsNullOrEmpty(this.dicCRemoteBanInfo[cPunkbusterInfo.SoldierName].strCountry) && !String.IsNullOrEmpty(cPunkbusterInfo.PlayerCountryCode)))
						{

							LockCookie lockCookie = this.rwLock.UpgradeToWriterLock(new TimeSpan(1000));
							try
							{
								if (String.IsNullOrEmpty(this.dicCRemoteBanInfo[cPunkbusterInfo.SoldierName].strPBGUID) && !String.IsNullOrEmpty(cPunkbusterInfo.GUID))
								{
									this.dicCRemoteBanInfo[cPunkbusterInfo.SoldierName].strPBGUID = cPunkbusterInfo.GUID;
								}
								if (String.IsNullOrEmpty(this.dicCRemoteBanInfo[cPunkbusterInfo.SoldierName].strCountry) && !String.IsNullOrEmpty(cPunkbusterInfo.PlayerCountryCode))
								{
									this.dicCRemoteBanInfo[cPunkbusterInfo.SoldierName].strCountry = cPunkbusterInfo.PlayerCountryCode;
								}
								return true;
							}
							catch (Exception ex)
							{
								strErrorMsg = ex.Message;
							}
							finally
							{
								this.rwLock.DowngradeFromWriterLock(ref lockCookie);
							}
							if (String.IsNullOrEmpty(strErrorMsg)) strErrorMsg = "something went wrong!";
							return false;
						}
						return true;
					}
					else
					{
						LockCookie lockCookie = this.rwLock.UpgradeToWriterLock(new TimeSpan(1000));
						try
						{
							CRemoteBanInfo cRemoteBanInfo = new CRemoteBanInfo();
							cRemoteBanInfo.strPBGUID = cPunkbusterInfo.GUID;
							cRemoteBanInfo.strSoldierName = cPunkbusterInfo.SoldierName;
							cRemoteBanInfo.strCountry = cPunkbusterInfo.PlayerCountryCode;
							this.dicCRemoteBanInfo.Add(cPunkbusterInfo.SoldierName, cRemoteBanInfo);
							return true;
						}
						catch (Exception ex)
						{
							strErrorMsg = ex.Message;
						}
						finally
						{
							this.rwLock.DowngradeFromWriterLock(ref lockCookie);
						}
						if (String.IsNullOrEmpty(strErrorMsg)) strErrorMsg = "something went wrong!";
						return false;
					}
				}
				catch (Exception ex)
				{
					strErrorMsg = ex.Message;
				}
				finally
				{
					this.rwLock.ReleaseReaderLock();
				}
				if (String.IsNullOrEmpty(strErrorMsg)) strErrorMsg = "something went wrong!";
				return false;
			}

			/// <summary>
			/// use to get a CRemoteBanInfo object (thread safe)
			/// </summary>
			/// <param name="strSoldierName"></param>
			/// <returns>CRemoteBanInfo object on success, null on error or not found</returns>
			public CRemoteBanInfo GetPlayerInfo(string strSoldierName, out string strErrorMsg)
			{
				this.rwLock.AcquireReaderLock(new TimeSpan(1000));
				strErrorMsg = String.Empty;
				try
				{
					if (this.dicCRemoteBanInfo.ContainsKey(strSoldierName))
					{
						return this.dicCRemoteBanInfo[strSoldierName];
					}
					return null;
				}
				catch (Exception ex)
				{
					strErrorMsg = ex.Message;
				}
				finally
				{
					this.rwLock.ReleaseReaderLock();
				}
				if (String.IsNullOrEmpty(strErrorMsg)) strErrorMsg = "something went wrong!";
				return null;
			}

			/// <summary>
			/// use to get the number of players stored (thread safe)
			/// </summary>
			/// <returns>the number of player, -1 on error</returns>
			public int GetSize()
			{
				this.rwLock.AcquireReaderLock(new TimeSpan(1000));

				try
				{
					return this.dicCRemoteBanInfo.Count;
				}
				catch (Exception ex)
				{

				}
				finally
				{
					this.rwLock.ReleaseReaderLock();
				}

				return -1;
			}

			/// <summary>
			/// search for PBGUID, EAGUID or IP in CBanDic
			/// </summary>
			/// <param name="strSearch"></param>
			/// <param name="strErrorMsg"></param>
			/// <returns>cRemoteBanInfo object on success, else null</returns>
			public CRemoteBanInfo SearchGUID(string strSearch, out string strErrorMsg)
			{
				this.rwLock.AcquireReaderLock(new TimeSpan(1000));
				strErrorMsg = String.Empty;
				try
				{
					foreach (KeyValuePair<string, CRemoteBanInfo> cRemoteBanInfo in this.dicCRemoteBanInfo)
					{
						if (strSearch.ToLower() == cRemoteBanInfo.Value.strEAGUID.ToLower() || strSearch.ToLower() == cRemoteBanInfo.Value.strPBGUID.ToLower())
						{
							return cRemoteBanInfo.Value;
						}
					}
					return null;
				}
				catch (Exception ex)
				{
					strErrorMsg = ex.Message;
				}
				finally
				{
					this.rwLock.ReleaseReaderLock();
				}
				if (String.IsNullOrEmpty(strErrorMsg)) strErrorMsg = "something went wrong!";
				return null;
			}

			/// <summary>
			/// removes player are stored in dictionary but not in commited list
			/// </summary>
			/// <param name="cPlayerInfoList"></param>
			public void CheckForRemoveable(List<CPlayerInfo> cPlayerInfoList)
			{
				this.rwLock.AcquireReaderLock(new TimeSpan(1000));
				try
				{
					bool isinlist;
					foreach (KeyValuePair<string, CRemoteBanInfo> cRemoteBanInfo in this.dicCRemoteBanInfo)
					{
						isinlist = false;
						foreach (CPlayerInfo cPlayerInfo in cPlayerInfoList)
						{
							if (String.Compare(cPlayerInfo.SoldierName, cRemoteBanInfo.Key) == 0)
							{
								isinlist = true;
								break;
							}
						}
						if (!isinlist)
						{
							LockCookie lockCookie = this.rwLock.UpgradeToWriterLock(new TimeSpan(1000));

							try
							{
								dicCRemoteBanInfo.Remove(cRemoteBanInfo.Key);
							}
							catch (Exception ex)
							{

							}
							finally
							{
								this.rwLock.DowngradeFromWriterLock(ref lockCookie);
							}

						}
					}
				}
				catch
				{

				}
				finally
				{
					this.rwLock.ReleaseReaderLock();
				}
			}

			/// <summary>
			/// returns a object if a commited string is in the and how often found
			/// </summary>
			/// <param name="strSoldierName"></param>
			/// <param name="count">count hits</param>
			/// <param name="strErrorMsg"></param>
			/// <returns>object if something is found, else null</returns>
			public CRemoteBanInfo ContainsSubString(string strSoldierName, out int count, out string strErrorMsg)
			{
				count = 0;
				strErrorMsg = String.Empty;
				this.rwLock.AcquireReaderLock(new TimeSpan(1000));
				try
				{
					CRemoteBanInfo cRemoteBanInfo = null;
					foreach (KeyValuePair<string, CRemoteBanInfo> cRemoteBanInfoKVPair in this.dicCRemoteBanInfo)
					{	
						if (cRemoteBanInfoKVPair.Key.ToLower().Contains(strSoldierName.ToLower()))
						{
							cRemoteBanInfo = cRemoteBanInfoKVPair.Value;
							count++;
						}
					}
					return cRemoteBanInfo;
				}
				catch (Exception ex)
				{
					strErrorMsg = ex.Message;
				}
				finally
				{
					this.rwLock.ReleaseReaderLock();
				}
				if (String.IsNullOrEmpty(strErrorMsg)) strErrorMsg = "something went wrong!";
				return null;
			}
		}

		private class ThreadSafeCleanPlayerDic
		{
			private Dictionary<string, CRemoteBanInfo> dicCRemoteBanInfo;
			private ReaderWriterLock rwLock;

			public ThreadSafeCleanPlayerDic()
			{
				this.rwLock = new ReaderWriterLock();
				this.rwLock.AcquireWriterLock(new TimeSpan(1000));
				try
				{
					this.dicCRemoteBanInfo = new Dictionary<string, CRemoteBanInfo>();
				}
				catch (Exception ex)
				{
					//TODO Fehler ausgeben
				}
				finally
				{
					this.rwLock.ReleaseWriterLock();
				}

			}

			/// <summary>
			/// add/update a cRemoteBanInfo object (thread safe)
			/// </summary>
			/// <param name="cRemoteBanInfo"></param>
			/// <returns>true on success else false</returns>
			public bool Add(CRemoteBanInfo cRemoteBanInfo, out string strErrorMsg)
			{
				this.rwLock.AcquireReaderLock(new TimeSpan(1000));
				strErrorMsg = String.Empty;
				try
				{
					if (!this.dicCRemoteBanInfo.ContainsKey(cRemoteBanInfo.strSoldierName))
					{
						LockCookie lockCookie = this.rwLock.UpgradeToWriterLock(new TimeSpan(1000));
						try
						{
							this.dicCRemoteBanInfo.Add(cRemoteBanInfo.strSoldierName, cRemoteBanInfo);
							return true;
						}
						catch (Exception ex)
						{
							strErrorMsg = ex.Message;
						}
						finally
						{
							this.rwLock.DowngradeFromWriterLock(ref lockCookie);
						}
						if (String.IsNullOrEmpty(strErrorMsg)) strErrorMsg = "something went wrong!";
						return false;
					}
					return true;
				}
				catch (Exception ex)
				{
					strErrorMsg = ex.Message;
				}
				finally
				{
					this.rwLock.ReleaseReaderLock();
				}
				return false;
			}

			/// <summary>
			/// removes a cRemoteBanInfo object 
			/// </summary>
			/// <param name="cRemoteBanInfo"></param>
			/// <returns>true on success or not found, else false</returns>
			public bool Remove(string strSoldierName, out string strErrorMsg)
			{
				this.rwLock.AcquireWriterLock(new TimeSpan(1000));
				strErrorMsg = String.Empty;
				try
				{
					if (this.dicCRemoteBanInfo.ContainsKey(strSoldierName))
					{
						this.dicCRemoteBanInfo.Remove(strSoldierName);
					}
					return true;
				}
				catch (Exception ex)
				{
					strErrorMsg = ex.Message;
				}
				finally
				{
					this.rwLock.ReleaseWriterLock();
				}
				if (String.IsNullOrEmpty(strErrorMsg)) strErrorMsg = "something went wrong!";
				return false;
			}

			/// <summary>
			/// return a CRemoteBanInfo object (thread safe)
			/// </summary>
			/// <param name="strSoldierName"></param>
			/// <returns>CRemoteBan object if found else return null</returns>
			public CRemoteBanInfo getPlayerInfo(string strSoldierName, out string strErrorMsg)
			{
				this.rwLock.AcquireReaderLock(new TimeSpan(1000));
				strErrorMsg = String.Empty;
				try
				{
					if (this.dicCRemoteBanInfo.ContainsKey(strSoldierName))
					{
						return this.dicCRemoteBanInfo[strSoldierName];
					}
					strErrorMsg = "no error but could not find player in cleanplayerdic: " + strSoldierName;
					return null;
				}
				catch (Exception ex)
				{
					strErrorMsg = ex.Message;
				}
				finally
				{
					this.rwLock.ReleaseReaderLock();
				}
				if (String.IsNullOrEmpty(strErrorMsg)) strErrorMsg = "something went wrong!";
				return null;
			}

			/// <summary>
			/// returns the number of players are stored (thread safe)
			/// </summary>
			/// <param name="strError"></param>
			/// <returns>the number of players are stored, -1 on error</returns>
			public int GetSize()
			{
				this.rwLock.AcquireReaderLock(new TimeSpan(1000));

				try
				{
					return dicCRemoteBanInfo.Count;
				}
				catch (Exception ex)
				{

				}
				finally
				{
					this.rwLock.ReleaseReaderLock();
				}

				return -1;
			}

			/// <summary>
			/// use this lookup if player is in or not (thread safe)
			/// </summary>
			/// <param name="strSoldierName"></param>
			/// <param name="strErrorMsg"></param>
			/// <returns>return true if player in list, return false on error(strError!=null)  and player no in list (strError = null)</returns>
			public bool Contains(string strSoldierName, out string strErrorMsg)
			{
				this.rwLock.AcquireReaderLock(new TimeSpan(1000));
				strErrorMsg = String.Empty;
				try
				{
					if (this.dicCRemoteBanInfo.ContainsKey(strSoldierName)) return true;
					else return false;
				}
				catch (Exception ex)
				{
					strErrorMsg = ex.Message;
				}
				finally
				{
					this.rwLock.ReleaseReaderLock();
				}
				if (String.IsNullOrEmpty(strErrorMsg)) strErrorMsg = "something went wrong!";
				return false;
			}

			/// <summary>
			/// removes player are stored in dictionary but not in commited list
			/// </summary>
			/// <param name="cPlayerInfoList"></param>
			public void CheckForRemoveable(List<CPlayerInfo> cPlayerInfoList)
			{
				this.rwLock.AcquireReaderLock(new TimeSpan(1000));

				try
				{
					bool isinlist;
					foreach (KeyValuePair<string, CRemoteBanInfo> cRemoteBanInfo in this.dicCRemoteBanInfo)
					{
						isinlist = false;

						foreach (CPlayerInfo cPlayerInfo in cPlayerInfoList)
						{
							if (String.Compare(cPlayerInfo.SoldierName, cRemoteBanInfo.Key) == 0)
							{
								isinlist = true;
								break;
							}
						}
						if (!isinlist)
						{

							LockCookie lockCookie = this.rwLock.UpgradeToWriterLock(new TimeSpan(1000));
							try
							{
								dicCRemoteBanInfo.Remove(cRemoteBanInfo.Key);
							}
							catch (Exception ex)
							{
								//TODO Fehler ausgeben
							}
							finally
							{
								this.rwLock.DowngradeFromWriterLock(ref lockCookie);
							}
						}
					}
				}
				catch (Exception ex)
				{
					//TODO Fehler ausgeben
				}
				finally
				{
					this.rwLock.ReleaseReaderLock();
				}
			}
		}
		#endregion
	}
}

